//===================================================================
// Apci01w.pas
//-------------------------------------------------------------------
// Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//===================================================================
unit Apci01w;

interface

uses
  Windows, SysUtils;

const
	//-----------------------------------------------------------------
	// װ
	//-----------------------------------------------------------------
	APCI01_SUCCESS							=0;
	APCI01_ERR_SYSTEM						=1;
  APCI01_ERR_NO_DEVICE				=2;
  APCI01_ERR_IN_USE						=3;
  APCI01_ERR_INVALID_SOCKET		=4;
  APCI01_ERR_RESOURCE					=5;
	APCI01_ERR_INVALID_ARGUMENT	=6;
	APCI01_ERR_NOTINIT					=7;
	APCI01_ERR_MODE							=8;
	APCI01_ERR_TIMEOUT					=9;
	APCI01_ERR_NOLSN						=10;
	APCI01_ERR_BUSY							=11;
	APCI01_ERR_ETC							=12;
	APCI01_ERR_WRAPDLL					=$ffff;	// ׯ߰֐װ
	//-----------------------------------------------------------------
	// ײү(GPIB)w
	//-----------------------------------------------------------------
	LA_0												=$20;		// OLA
  TA_0												=$40;		// OTA
	UNL													=$3f;		// UNListen
	UNT													=$5F;		// UNTalk
	GTL													=$01;		// Go To Local
	SDC													=$04;		// Select Device Clear
	GET													=$08;		// Group Execute Trigger
	LLO													=$11;		// Local Lock Out
	DCL													=$14;		// Device Clear
	SPE													=$18;		// Serial Poll Enable
	SPD													=$19;		// Serial Poll Disable
	PPC													=$05;		// Parallel Poll Config
	PPE													=$60;		// Parallel Poll Enable
	PPZ													=$70;		// Parallel Poll Disable
	PPU													=$15;		// Parallel Poll Unconfig
	TCT													=$09;		// Take Control (XXX)
	//-----------------------------------------------------------------
	// GPIBð擾
	//-----------------------------------------------------------------
	STS_IFC											=$01;		// IFC
	STS_DCAS										=$02;		// DeviceClear
	STS_UNC											=$04;		// Ppoll,TCT etc
	STS_ERR											=$08;		// Error
	STS_GET											=$10;		// GET
	STS_SPAS										=$20;		// Spoll
	STS_END											=$40;		// END
	STS_REM											=$00;		// Remote
	STS_LLO											=$00;		// LLO
	STS_TLK											=$00;		// Talker
	STS_LSN											=$00;		// Listener
	STS_ATN											=$00;		// ATN
	STS_SRQ											=$00;		// SRQ
	STS_REN											=$00;		// REN
	//-----------------------------------------------------------------
	// GPIB֘AҰw͈
	//-----------------------------------------------------------------
	ADDR_MIN										=0;			// ŏGPIBڽ
	ADDR_MAX										=30;		// ő    "
	TIMEOUT_DEFAULT							=2000;	// ѱ̫
	TIMEOUT_MAX									=60000;	// ѱčől
	//-----------------------------------------------------------------
	// GPIBӰގw
	//-----------------------------------------------------------------
	MODE_SYSCON									=1;			// Ѻ۰Ӱ
	MODE_TLKLSN									=0;			// İؽӰ
	//-----------------------------------------------------------------
	// Ӱގw
	//-----------------------------------------------------------------
	DELIM_CRLF									=1;			// CR + LF(̫)
	DELIM_CR										=2;			// CR
	DELIM_LF										=3;			// LF
	DELIM_NO										=0;			// NOTHING
	//-----------------------------------------------------------------
	// EOIӰގw
	//-----------------------------------------------------------------
	EOI_ON											=1;			// t(̫)
	EOI_OFF											=0;			// Ȃ
	//-----------------------------------------------------------------
	// ̑萔
	//-----------------------------------------------------------------
	APCI01_DLL_NAME							='Apci01.dll';
	APCI01_SLOT_AUTO						=$FFFF;
	APCI01_MAX_SLOTS						=16;
	//-----------------------------------------------------------------
	// ؿ\
	//-----------------------------------------------------------------
	APCI01_NMAX_MEM	=	9;
	APCI01_NMAX_IO	= 20;
	APCI01_NMAX_IRQ	=	7;
	APCI01_NMAX_DMA	=	7;
type
	TAPCI01RESOURCE = record
		dwNumMemWindows:																DWORD;	// س޳(gp)
		dwMemBase:			array [1 .. APCI01_NMAX_MEM] of	DWORD;	// س޳ްڽ(gp)
		dwMemLength:		array [1 .. APCI01_NMAX_MEM] of	DWORD;	// س޳(gp)
		dwMemAttrib:		array [1 .. APCI01_NMAX_MEM] of	DWORD;	// س޳(gp)
		dwNumIOPorts:																		DWORD;	// I/O߰Đ
		dwIOPortBase:		array [1 .. APCI01_NMAX_IO]	 of	DWORD;	// I/O߰ްڽ
		dwIOPortLength: array [1 .. APCI01_NMAX_IO]	 of	DWORD;	// I/O߰Ē
		dwNumIRQs:																			DWORD;	// IRQ
		dwIRQRegisters: array [1 .. APCI01_NMAX_IRQ] of	DWORD;	// IRQؽ
		dwIRQAttrib:		array [1 .. APCI01_NMAX_IRQ] of	DWORD;	// IRQؽ
		dwNumDMAs:																			DWORD;	// DMAِ(gp)
		dwDMALst:				array [1 .. APCI01_NMAX_DMA] of	DWORD;	// DMAؽ(gp)
		dwDMAAttrib:		array [1 .. APCI01_NMAX_DMA] of	DWORD;	// DMAّؽ(gp)
		dwReserved1:		array [1 .. 3] 					 		 of	DWORD;	// \(gp)
	end;
	PAPCI01RESOURCE = ^TAPCI01RESOURCE;
//-------------------------------------------------------------------
// J֐
//-------------------------------------------------------------------

// DLL ۰
function Apci01wDllOpen: Boolean;
// DLL ۰
function Apci01wDllClose: Boolean;
// װގ擾
function Apci01wGetLastError(wLogSlot:WORD): DWORD;
// GPIBð̎擾
function Apci01wGetStatus(wLogSlot:WORD): DWORD;
// DLL,޲ײްްޮݔԍ擾
function Apci01wGetVersion(var pdwDllVersion:DWORD; var pdwDriverVersion:DWORD): Boolean;
// ޲̎gp錾
function Apci01wCreate(var pwLogSlot:WORD): Boolean;
// ޲J
function Apci01wClose(wLogSlot:WORD): Boolean;
// ؿ擾
function Apci01wGetResource(wLogSlot:WORD; pResInfo:PAPCI01RESOURCE): Boolean;
// GPIB
function Apci01wInit(wLogSlot,wGpibAddr,wGpibMode:Word; dwFifoSize:DWord): Boolean;
// GPIBѱĐݒ
function Apci01wSetTime(wLogSlot:Word; dwTimeoutCnt:DWord): Boolean;
// EOIݒ
function Apci01wSetEos(wLogSlot,wDlmMode,wEoiMode:Word): Boolean;
// GPIBޑM(۰חp)
function Apci01wSendCmd(wLogSlot:Word; var paSendBuf:array of Byte; dwSendBytes:DWord): Boolean;
// IFCM(۰חp)
function Apci01wIfc(wLogSlot:Word): Boolean;
// RENײ݂̐ݒ(۰חp)
function Apci01wRen(wLogSlot,wRenLine:Word): Boolean;
// DCLM(۰חp)
function Apci01wDcl(wLogSlot:Word): Boolean;
// w@ւSDCM(۰חp)
function Apci01wSdc(wLogSlot,wLsnAdrs:Word): Boolean;
// ̎w@ւްM(۰חp)
function Apci01wSendDataCN(wLogSlot:Word; var pwLsnAdrsList:array of Word; wLsnAdrsCnt:Word; var pbSendBuff:array of Byte; dwDataCnt:DWord): Boolean;
// w@ւްM(۰חp)
function Apci01wSendDataC(wLogSlot,wLsnAdrs:Word; var pbSendBuff:array of Byte; dwDataCnt:DWord): Boolean;
// ްM(ڰޗp)
function Apci01wSendDataS(wLogSlot:Word; var pbSendBuff:array of Byte; dwDataCnt:DWord): Boolean;
// w@킩ްM(۰חp)
function Apci01wRecvDataC(wLogSlot,wTlkAdrs:Word; var pbRecvBuff:array of Byte; var pdwDataCnt:DWord): Boolean;
// ްM(ڰޗp)
function Apci01wRecvDataS(wLogSlot:Word; var pbRecvBuff:array of Byte; var pdwDataCnt:DWord): Boolean;
// @ް](۰חp)
function Apci01wTransDataN(wLogSlot,wTlkAdrs:Word; var pwLsnAdrsList:array of Word; wLsnAdrsCnt:Word): Boolean;
// @ް](۰חp)
function Apci01wTransData(wLogSlot,wTlkAdrs,wLsnAdrs:Word): Boolean;
// SRQײ݂ƽð޲Đݒ(ڰޗp)
function Apci01wSetSrqLine(wLogSlot:Word; bStsByte:Byte): Boolean;
// SRQײ݂̏Ԕ(۰חp)
function Apci01wGetSrqLine(wLogSlot:Word; var pwSrqLine:Word): Boolean;
// رَ߰s(۰חp)
function Apci01wSpoll(wLogSlot,wPollAdrs:Word; var pbStsByte:Byte): Boolean;
// َ߰s(۰חp)
function Apci01wPpoll(wLogSlot:Word; var pbDioLine:Byte): Boolean;
// ٍ߰\(۰חp)
function Apci01wPpollConfig(wLogSlot,wLsnAdrs:Word; bDioLine:Byte; bSbit:Byte): Boolean;
// w@ٍ߰\(۰חp)
function Apci01wPpollUnConfig(wLogSlot,wLsnAdrs:Word): Boolean;
// S@ٍ߰\(۰חp)
function Apci01wPpollUnConfigAll(wLogSlot:Word): Boolean;
// ߰ىݒ(ڰޗp)
function Apci01wPpollRespModeSet(wLogSlot,wPMode:Word): Boolean;
// BSN Switch ̒l擾
function Apci01wGetSwitchValue(wLogSlot:Word;var pdwSwitchValue:DWord):Boolean;
// DIP-SW ̒l擾
function Apci01wGetDipSwitch(wLogSlot:Word;var pbDipsw:Byte):Boolean;

//-------------------------------------------------------------------
// (STATIC)ϐȂ
//-------------------------------------------------------------------
implementation

{$J+}	// ^t萔̕ύX\߲׎w
const
	hDLL: THandle = 0;
type
	TApci01GetLastError 		= function(wLogSlot:WORD): DWORD; stdcall;
	TApci01GetStatus 				= function(wLogSlot:WORD): DWORD; stdcall;
	TApci01GetVersion 			= function(var pdwDllVersion:DWORD; var pdwDriverVersion:DWORD): Boolean; stdcall;
	TApci01Create 					= function(var pwLogSlot): Boolean; stdcall;
	TApci01Close 						= function(wLogSlot:WORD): Boolean; stdcall;
	TApci01GetResource 			= function(wLogSlot:WORD; pResInfo:PAPCI01RESOURCE): Boolean; stdcall;
	TApci01Init 						= function(wLogSlot,wGpibAddr,wGpibMode:Word; dwFifoSize:DWord): Boolean; stdcall;
	TApci01SetTime 					= function(wLogSlot:Word; dwTimeoutCnt:DWord): Boolean; stdcall;
	TApci01SetEos 					= function(wLogSlot,wDlmMode,wEoiMode:Word): Boolean; stdcall;
	TApci01SendCmd 					= function(wLogSlot:Word; paSendBuf:PChar; dwSendBytes:DWord): Boolean; stdcall;
	TApci01Ifc 							= function(wLogSlot:Word): Boolean; stdcall;
	TApci01Ren 							= function(wLogSlot,wRenLine:Word): Boolean; stdcall;
	TApci01Dcl 							= function(wLogSlot:Word): Boolean; stdcall;
	TApci01Sdc 							= function(wLogSlot,wLsnAdrs:Word): Boolean; stdcall;
	TApci01SendDataCN 			= function(wLogSlot:Word; pwLsnAdrsList:PWordArray; wLsnAdrsCnt:Word; pbSendBuff:PChar; dwDataCnt:DWord): Boolean; stdcall;
	TApci01SendDataC 				= function(wLogSlot,wLsnAdrs:Word; pbSendBuff:PChar; dwDataCnt:DWord): Boolean; stdcall;
	TApci01SendDataS 				= function(wLogSlot:Word; pbSendBuff:PChar; dwDataCnt:DWord): Boolean; stdcall;
	TApci01RecvDataC 				= function(wLogSlot,wTlkAdrs:Word; pbRecvBuff:PChar; var pdwDataCnt:DWord): Boolean; stdcall;
	TApci01RecvDataS 				= function(wLogSlot:Word; pbRecvBuff:PChar; var pdwDataCnt:DWord): Boolean; stdcall;
	TApci01TransDataN 			= function(wLogSlot,wTlkAdrs:Word; pwLsnAdrsList:PWordArray; wLsnAdrsCnt:Word): Boolean; stdcall;
	TApci01TransData 				= function(wLogSlot,wTlkAdrs,wLsnAdrs:Word): Boolean; stdcall;
	TApci01SetSrqLine 			= function(wLogSlot:Word; bStsByte:Byte): Boolean; stdcall;
	TApci01GetSrqLine 			= function(wLogSlot:Word; var pwSrqLine:Word): Boolean; stdcall;
	TApci01Spoll 						= function(wLogSlot,wPollAdrs:Word; var pbStsByte:Byte): Boolean; stdcall;
	TApci01Ppoll 						= function(wLogSlot:Word; var pbDioLine:Byte): Boolean; stdcall;
	TApci01PpollConfig 			= function(wLogSlot,wLsnAdrs:Word; bDioLine:Byte; bSbit:Byte): Boolean; stdcall;
	TApci01PpollUnConfig 		= function(wLogSlot,wLsnAdrs:Word): Boolean; stdcall;
	TApci01PpollUnConfigAll = function(wLogSlot:Word): Boolean; stdcall;
	TApci01PpollRespModeSet = function(wLogSlot,wPMode:Word): Boolean; stdcall;
	TApci01GetSwitchValue		= function(wLogSlot:Word;var pdwSwitchValue:DWord):Boolean;stdcall;
	TApci01GetDipSwitch 		= function(wLogSlot:Word;var pbDipsw:Byte):Boolean;stdcall;

// DLL ߰Ċ֐ڽ̊i[ϐ
var
	pApci01GetLastError:			TApci01GetLastError;
	pApci01GetStatus:					TApci01GetStatus;
	pApci01GetVersion: 				TApci01GetVersion;
	pApci01Create: 						TApci01Create;
	pApci01Close: 						TApci01Close;
	pApci01GetResource: 			TApci01GetResource;
	pApci01Init:							TApci01Init;
	pApci01SetTime:						TApci01SetTime;
	pApci01SetEos:						TApci01SetEos;
	pApci01SendCmd:						TApci01SendCmd;
	pApci01Ifc:								TApci01Ifc;
	pApci01Ren:								TApci01Ren;
	pApci01Dcl:								TApci01Dcl;
	pApci01Sdc:								TApci01Sdc;
	pApci01SendDataCN:				TApci01SendDataCN;
	pApci01SendDataC:					TApci01SendDataC;
	pApci01SendDataS:					TApci01SendDataS;
	pApci01RecvDataC:					TApci01RecvDataC;
	pApci01RecvDataS:					TApci01RecvDataS;
	pApci01TransDataN:				TApci01TransDataN;
	pApci01TransData:					TApci01TransData;
	pApci01SetSrqLine:				TApci01SetSrqLine;
	pApci01GetSrqLine:				TApci01GetSrqLine;
	pApci01Spoll:							TApci01Spoll;
	pApci01Ppoll:							TApci01Ppoll;
	pApci01PpollConfig:				TApci01PpollConfig;
	pApci01PpollUnConfig:			TApci01PpollUnConfig;
	pApci01PpollUnConfigAll:	TApci01PpollUnConfigAll;
	pApci01PpollRespModeSet:	TApci01PpollRespModeSet;
	pApci01GetSwitchValue:		TApci01GetSwitchValue;
	pApci01GetDipSwitch:			TApci01GetDipSwitch;

  function _Apci01wGetDllExportFunc: Boolean; forward;

{$J-}

//===================================================================
// 		DLL۰(۰ގʹװƂ)
// 		
// ߂l  True
//				s False
//===================================================================
function Apci01wDllOpen: Boolean;
begin
	Result:=False;
	if hDLL=0 then begin
		hDLL:=LoadLibrary(APCI01_DLL_NAME);
		if hDLL<>0 then begin
			if _Apci01wGetDllExportFunc=True then begin
      	Result:=True
			end else Apci01wDllClose;	// DLL֐擾ɎŝDLLN[Y
		end;
	end;
end;
//===================================================================
// 		DLL۰(۰ގʹװƂ)
// 		
// ߂l  True
//				s False
//===================================================================
function Apci01wDllClose: Boolean;
begin
	Result:=False;
	if hDLL<>0 then begin
		if True=FreeLibrary(hDLL) then begin
			hDLL:=0;
			Result:=True;
		end;
	end;
end;
//===================================================================
// 		װނ̎擾
// 		wLogSlot	޲̘_ۯĔԍ
// ߂l װ
//===================================================================
function Apci01wGetLastError(wLogSlot:WORD): DWORD;
begin
	if hDLL=0 then Result:=APCI01_ERR_WRAPDLL
	else Result:=pApci01GetLastError(wLogSlot)
end;
//===================================================================
// 		GPIBð̎擾
// 		wLogSlot	޲̘_ۯĔԍ
// ߂l  True
//				s False
//===================================================================
function Apci01wGetStatus(wLogSlot:WORD): DWORD;
begin
	Result := 0;
	if hDLL = 0 then Exit;
	Result:=pApci01GetStatus(wLogSlot);
end;
//===================================================================
// 		DLL,޲ײްްޮݔԍ擾
// 		pdwDllVersion			DLLްޮݔԍi[̈ւ߲
//				pdwDriverVersion	޲ײްްޮݔԍi[̈ւ߲
// ߂l  True
//				s False
//===================================================================
function Apci01wGetVersion(var pdwDllVersion:DWORD; var pdwDriverVersion:DWORD): Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci01GetVersion(pdwDllVersion, pdwDriverVersion);
end;
//===================================================================
// 		޲̎gp錾
// 		pwLogSlot	 	gp޲̘_ۯĔԍi[߲
// ߂l  True
//				s False
//===================================================================
function Apci01wCreate(var pwLogSlot:WORD): Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci01Create(pwLogSlot);
end;
//===================================================================
// 		޲J
// 		wLogSlot 		޲̘_ۯĔԍ
// ߂l  True
//				s False
//===================================================================
function Apci01wClose(wLogSlot:WORD): Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci01Close(wLogSlot)
end;
//===================================================================
// 		w޲ؿ擾
// 		wLogSlot		޲̘_ۯĔԍ
//				pResInfo		ؿi[\߲̂
// ߂l  True
//				s False
//===================================================================
function Apci01wGetResource(wLogSlot:WORD; pResInfo:PAPCI01RESOURCE): Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci01GetResource(wLogSlot, pResInfo)
end;
//===================================================================
// 		
// 		wLogSlot		޲̘_ۯĔԍ
//				wGpibAddr   g GP-IB AhX
//				wGpibMode		g GP-IB 샂[h
//				dwFifoSize	Mobt@̑傫
// ߂l  True
//				s False
//===================================================================
function Apci01wInit(wLogSlot,wGpibAddr,wGpibMode:Word; dwFifoSize:DWord): Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci01Init(wLogSlot,wGpibAddr,wGpibMode,dwFifoSize);
end;
//===================================================================
// 		GPIBѱĐݒ
// 		wLogSlot			޲̘_ۯĔԍ
//				dwTimeoutCnt  ^CAEglBPʂ̓~b0`60000܂ŁB
// ߂l  True
//				s False
//===================================================================
function Apci01wSetTime(wLogSlot:Word; dwTimeoutCnt:DWord): Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci01SetTime(wLogSlot,dwTimeoutCnt);
end;
//===================================================================
// 		EOIݒ
// 		wLogSlot		޲̘_ۯĔԍ
//				wDlmMode    f~^w
//				wEoiMode    dnh̎gp܂͕sgpw
// ߂l  True
//				s False
//===================================================================
function Apci01wSetEos(wLogSlot,wDlmMode,wEoiMode:Word): Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci01SetEos(wLogSlot,wDlmMode,wEoiMode);
end;
//===================================================================
// 		GPIBޑM(۰חp)
// 		wLogSlot		޲̘_ۯĔԍ
//				paSendBuf   MR}hobt@̃AhX
//				dwSendBytes	MׂR}h̃oCg
// ߂l  True
//				s False
//===================================================================
function Apci01wSendCmd(wLogSlot:Word; var paSendBuf:array of Byte; dwSendBytes:DWord): Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci01SendCmd(wLogSlot,PChar(@paSendBuf),dwSendBytes);
end;
//===================================================================
// 		IFCM(۰חp)
// 		wLogSlot		޲̘_ۯĔԍ
// ߂l  True
//				s False
//===================================================================
function Apci01wIfc(wLogSlot:Word): Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci01Ifc(wLogSlot);
end;
//===================================================================
// 		RENײ݂̐ݒ(۰חp)
// 		wLogSlot		޲̘_ۯĔԍ
//				wRenLine		1(^)/0(U)
// ߂l  True
//				s False
//===================================================================
function Apci01wRen(wLogSlot,wRenLine:Word): Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci01Ren(wLogSlot,wRenLine);
end;
//===================================================================
// 		DCLM(۰חp)
// 		wLogSlot	޲̘_ۯĔԍ
// ߂l  True
//				s False
//===================================================================
function Apci01wDcl(wLogSlot:Word): Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci01Dcl(wLogSlot);
end;
//===================================================================
// 		w@ւSDCM(۰חp)
// 		wLogSlot		޲̘_ۯĔԍ
//				wLsnAdrs		XiAhX
// ߂l  True
//				s False
//===================================================================
function Apci01wSdc(wLogSlot,wLsnAdrs:Word): Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci01Sdc(wLogSlot,wLsnAdrs);
end;
//===================================================================
// 		̎w@ւްM(۰חp)
// 		wLogSlot			޲̘_ۯĔԍ
//				pwLsnAdrsList XiAhXXg̃AhX
//				wLsnAdrsCnt		XiAhX̐
//				pbSendBuff		Mf[^obt@̃AhX
//				dwDataCnt			Mf[^
// ߂l  True
//				s False
//===================================================================
function Apci01wSendDataCN(wLogSlot:Word; var pwLsnAdrsList:array of Word; wLsnAdrsCnt:Word; var pbSendBuff:array of Byte; dwDataCnt:DWord): Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci01SendDataCN(wLogSlot,PWordArray(@pwLsnAdrsList),wLsnAdrsCnt,PChar(@pbSendBuff),dwDataCnt);
end;
//===================================================================
// 		w@ւްM(۰חp)
// 		wLogSlot		޲̘_ۯĔԍ
//				wLsnAdrs		XiAhX
//				pbSendBuff	Mf[^obt@̃AhX
//				dwDataCnt   Mf[^
// ߂l  True
//				s False
//===================================================================
function Apci01wSendDataC(wLogSlot,wLsnAdrs:Word; var pbSendBuff:array of Byte; dwDataCnt:DWord): Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci01SendDataC(wLogSlot,wLsnAdrs,PChar(@pbSendBuff),dwDataCnt);
end;
//===================================================================
// 		ްM(ڰޗp)
// 		wLogSlot		޲̘_ۯĔԍ
//				pbSendBuff	Mf[^obt@̃AhX
//				dwDataCnt		Mf[^
// ߂l  True
//				s False
//===================================================================
function Apci01wSendDataS(wLogSlot:Word; var pbSendBuff:array of Byte; dwDataCnt:DWord): Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci01SendDataS(wLogSlot,PChar(@pbSendBuff),dwDataCnt);
end;
//===================================================================
// 		w@킩ްM(۰חp)
// 		wLogSlot		޲̘_ۯĔԍ
//				wTlkAdrs		g[JAhX
//				pbRecvBuff	Mf[^obt@̃AhX
//				pdwDataCnt	Mf[^w肷ϐ̃AhX
// ߂l  True
//				s False
//===================================================================
function Apci01wRecvDataC(wLogSlot,wTlkAdrs:Word; var pbRecvBuff:array of Byte; var pdwDataCnt:DWord): Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci01RecvDataC(wLogSlot,wTlkAdrs,PChar(@pbRecvBuff),pdwDataCnt);
end;
//===================================================================
// 		ްM(ڰޗp)
// 		wLogSlot		޲̘_ۯĔԍ
//				pbRecvBuff  Mf[^obt@̃AhX
//				pdwDataCnt  Mf[^w肷ϐ̃AhX
// ߂l  True
//				s False
//===================================================================
function Apci01wRecvDataS(wLogSlot:Word; var pbRecvBuff:array of Byte; var pdwDataCnt:DWord): Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci01RecvDataS(wLogSlot,PChar(@pbRecvBuff),pdwDataCnt);
end;
//===================================================================
// 		@ް](۰חp)
// 		wLogSlot			޲̘_ۯĔԍ
//				wTlkAdrs      g[JAhX
//				pwLsnAdrsList	XiAhXXg̃AhX
//				wLsnAdrsCnt		XiAhX̐
// ߂l  True
//				s False
//===================================================================
function Apci01wTransDataN(wLogSlot,wTlkAdrs:Word; var pwLsnAdrsList:array of Word; wLsnAdrsCnt:Word): Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci01TransDataN(wLogSlot,wTlkAdrs,PWordArray(@pwLsnAdrsList),wLsnAdrsCnt);
end;
//===================================================================
// 		@ް](۰חp)
// 		wLogSlot		޲̘_ۯĔԍ
//				wTlkAdrs		g[JAhX
//				wLsnAdrs		XiAhX
// ߂l  True
//				s False
//===================================================================
function Apci01wTransData(wLogSlot,wTlkAdrs,wLsnAdrs:Word): Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci01TransData(wLogSlot,wTlkAdrs,wLsnAdrs);
end;
//===================================================================
// 		SRQײ݂ƽð޲Đݒ(ڰޗp)
// 		wLogSlot		޲̘_ۯĔԍ
//				bStsByte		Xe[^XoCgl
// ߂l  True
//				s False
//===================================================================
function Apci01wSetSrqLine(wLogSlot:Word; bStsByte:Byte): Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci01SetSrqLine(wLogSlot,bStsByte);
end;
//===================================================================
// 		SRQײ݂̏Ԕ(۰חp)
// 		wLogSlot		޲̘_ۯĔԍ
//				pwSrqLine		rqpCԂi[ϐ̃AhX
// ߂l  True
//				s False
//===================================================================
function Apci01wGetSrqLine(wLogSlot:Word; var pwSrqLine:Word): Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci01GetSrqLine(wLogSlot,pwSrqLine);
end;
//===================================================================
// 		رَ߰s(۰חp)
// 		wLogSlot		޲̘_ۯĔԍ
//				wPollAdrs		|[ÕAhX
//				pbStsByte		Xe[^XoCgi[ϐ̃AhX
// ߂l  True
//				s False
//===================================================================
function Apci01wSpoll(wLogSlot,wPollAdrs:Word; var pbStsByte:Byte): Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci01Spoll(wLogSlot,wPollAdrs,pbStsByte);
end;
//===================================================================
// 		َ߰s(۰חp)
// 		wLogSlot		޲̘_ۯĔԍ
//				pbDioLine   chnCi[ϐ̃AhX
// ߂l  True
//				s False
//===================================================================
function Apci01wPpoll(wLogSlot:Word; var pbDioLine:Byte): Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci01Ppoll(wLogSlot,pbDioLine);
end;
//===================================================================
// 		ٍ߰\(۰חp)
// 		wLogSlot		޲̘_ۯĔԍ
//				wLsnAdrs		\@AhX
//				bDioLine    @tDIOCԍiO`ṼrbgԍŎwj
//				bSbit				ZXrbg̎wiO܂͂Pj
// ߂l  True
//				s False
//===================================================================
function Apci01wPpollConfig(wLogSlot,wLsnAdrs:Word; bDioLine:Byte; bSbit:Byte): Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci01PpollConfig(wLogSlot,wLsnAdrs,bDioLine,bSbit);
end;
//===================================================================
// 		w@ٍ߰\(۰חp)
// 		wLogSlot		޲̘_ۯĔԍ
//				wLsnAdrs		\@AhX
// ߂l  True
//				s False
//===================================================================
function Apci01wPpollUnConfig(wLogSlot,wLsnAdrs:Word): Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci01PpollUnConfig(wLogSlot,wLsnAdrs);
end;
//===================================================================
// 		S@ٍ߰\(۰חp)
// 		wLogSlot		޲̘_ۯĔԍ
// ߂l  True
//				s False
//===================================================================
function Apci01wPpollUnConfigAll(wLogSlot:Word): Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci01PpollUnConfigAll(wLogSlot);
end;
//===================================================================
// 		߰ىݒ(ڰޗp)
// 		wLogSlot		޲̘_ۯĔԍ
//				wPMode			p|[ւ̉@
// ߂l  True
//				s False
//===================================================================
function Apci01wPpollRespModeSet(wLogSlot,wPMode:Word): Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci01PpollRespModeSet(wLogSlot,wPMode);
end;
//===================================================================
// 		arm̒l擾
// 		wLogSlot				޲̘_ۯĔԍ
//				pdwSwitchValue  arm̒li[̈
// ߂l  True
//				s False
//===================================================================
function Apci01wGetSwitchValue(wLogSlot: WORD; var pdwSwitchValue: DWORD ): Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci01GetSwitchValue(wLogSlot,pdwSwitchValue);
end;
//===================================================================
// 		DIP-SW ̒l擾܂
// 		wLogSlot				޲̘_ۯĔԍ
//				pbDipsw         DIP-SW̒li[̈
// ߂l  True
//				s False
//===================================================================
function Apci01wGetDipSwitch(wLogSlot: WORD; var pbDipsw: BYTE ): Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci01GetDipSwitch(wLogSlot,pbDipsw);
end;
//-------------------------------------------------------------------
// 	  DLL߰Ċ֐ڽ̎擾
// 	  
// ߂l  True
//		  	s False
//-------------------------------------------------------------------
function _Apci01wGetDllExportFunc: Boolean;
begin
	Result:=False;
	pApci01GetLastError:=GetProcAddress(hDLL, 'Apci01GetLastError');
	if @pApci01GetLastError=nil then Exit;
	pApci01GetStatus:=GetProcAddress(hDLL, 'Apci01GetStatus');
	if @pApci01GetStatus=nil then Exit;
	pApci01GetVersion:=GetProcAddress(hDLL, 'Apci01GetVersion');
	if @pApci01GetVersion=nil then Exit;
	pApci01Create:=GetProcAddress(hDLL, 'Apci01Create');
	if @pApci01Create=nil then Exit;
	pApci01Close:=GetProcAddress(hDLL, 'Apci01Close');
	if @pApci01Close=nil then Exit;
	pApci01GetResource:=GetProcAddress(hDLL, 'Apci01GetResource');
	if @pApci01GetResource=nil then Exit;
	pApci01Init:=GetProcAddress(hDLL, 'Apci01Init');
	if @pApci01Init=nil then Exit;
	pApci01SetTime:=GetProcAddress(hDLL, 'Apci01SetTime');
	if @pApci01SetTime=nil then Exit;
	pApci01SetEos:=GetProcAddress(hDLL, 'Apci01SetEos');
	if @pApci01SetEos=nil then Exit;
	pApci01SendCmd:=GetProcAddress(hDLL, 'Apci01SendCmd');
	if @pApci01SendCmd=nil then Exit;
	pApci01Ifc:=GetProcAddress(hDLL, 'Apci01Ifc');
	if @pApci01Ifc=nil then Exit;
	pApci01Ren:=GetProcAddress(hDLL, 'Apci01Ren');
	if @pApci01Ren=nil then Exit;
	pApci01Dcl:=GetProcAddress(hDLL, 'Apci01Dcl');
	if @pApci01Dcl=nil then Exit;
	pApci01Sdc:=GetProcAddress(hDLL, 'Apci01Sdc');
	if @pApci01Sdc=nil then Exit;
	pApci01SendDataCN:=GetProcAddress(hDLL, 'Apci01SendDataCN');
	if @pApci01SendDataCN=nil then Exit;
	pApci01SendDataC:=GetProcAddress(hDLL, 'Apci01SendDataC');
	if @pApci01SendDataC=nil then Exit;
	pApci01SendDataS:=GetProcAddress(hDLL, 'Apci01SendDataS');
	if @pApci01SendDataS=nil then Exit;
	pApci01RecvDataC:=GetProcAddress(hDLL, 'Apci01RecvDataC');
	if @pApci01RecvDataC=nil then Exit;
	pApci01RecvDataS:=GetProcAddress(hDLL, 'Apci01RecvDataS');
	if @pApci01RecvDataS=nil then Exit;
	pApci01TransDataN:=GetProcAddress(hDLL, 'Apci01TransDataN');
	if @pApci01TransDataN=nil then Exit;
	pApci01TransData:=GetProcAddress(hDLL, 'Apci01TransData');
	if @pApci01TransData=nil then Exit;
	pApci01SetSrqLine:=GetProcAddress(hDLL, 'Apci01SetSrqLine');
	if @pApci01SetSrqLine=nil then Exit;
	pApci01GetSrqLine:=GetProcAddress(hDLL, 'Apci01GetSrqLine');
	if @pApci01GetSrqLine=nil then Exit;
	pApci01Spoll:=GetProcAddress(hDLL, 'Apci01Spoll');
	if @pApci01Spoll=nil then Exit;
	pApci01Ppoll:=GetProcAddress(hDLL, 'Apci01Ppoll');
	if @pApci01Ppoll=nil then Exit;
	pApci01PpollConfig:=GetProcAddress(hDLL, 'Apci01PpollConfig');
	if @pApci01PpollConfig=nil then Exit;
	pApci01PpollUnConfig:=GetProcAddress(hDLL, 'Apci01PpollUnConfig');
	if @pApci01PpollUnConfig=nil then Exit;
	pApci01PpollUnConfigAll:=GetProcAddress(hDLL, 'Apci01PpollUnConfigAll');
	if @pApci01PpollUnConfigAll=nil then Exit;
	pApci01PpollRespModeSet:=GetProcAddress(hDLL, 'Apci01PpollRespModeSet');
	if @pApci01PpollRespModeSet=nil then Exit;
	pApci01GetSwitchValue:=GetProcAddress(hDLL, 'Apci01GetSwitchValue');
	if @pApci01GetSwitchValue=nil then Exit;
	pApci01GetDipSwitch:=GetProcAddress(hDLL, 'Apci01GetDipSwitch');
	if @pApci01GetDipSwitch=nil then Exit;

	// SĂ DLL ߰Ċ֐ڽ擾nj
	Result:=True;
end;

end.

