//============================================================================
// Apci01w.cs
//----------------------------------------------------------------------------
// aPCI-G01
// Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//============================================================================
using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Runtime.InteropServices;

namespace SampleG01
{
	/// <summary>
	/// Apci01w ̊Tv̐łB
	/// </summary>
	public class Apci01w
	{
		private int mErrWradll = SUCCESS;		// bp[֐G[

		//-------------------------------------------------------------------
		// G[R[h
		//-------------------------------------------------------------------
		public const int SUCCESS				= 0;	// ُȂiIj
		public const int ERR_SYSTEM				= 1;	// ɃhCo[hĂȂ\܂
		public const int ERR_NO_DEVICE			= 2;	// gp\ȃfoCX܂
		public const int ERR_IN_USE				= 3;	// w̃foCX͑̃vZXŎgpł
		public const int ERR_INVALID_SLOT		= 4;	// Ș_Xbgԍł
		public const int ERR_RESOURCE			= 5;	// \[XG[
		public const int ERR_INVALID_ARGUMENT	= 6;	// sȈw肵܂
		public const int ERR_NOTINIT			= 7;	// Ă܂B
		public const int ERR_MODE				= 8;	// GPIB ̃[hG[łB
		public const int ERR_TIMEOUT			= 9;	// ^CAEg܂B
		public const int ERR_NOLSN				= 10;	// XiiP[uڑj
		public const int ERR_BUSY				= 11;	// s
		public const int ERR_ETC				= 12;	// ̑̃G[
		public const int ERR_WRAPDLL			= -1;	// bp[֐G[

		//-------------------------------------------------------------------
		// GPIBXe[^X擾
		//-------------------------------------------------------------------
		public const int STS_IFC			= 0x1;		// IFC
		public const int STS_DCAS			= 0x2;		// DeviceClear
		public const int STS_UNC			= 0x4;		// Ppoll,TCT etc
		public const int STS_ERR			= 0x8;		// Error
		public const int STS_GET			= 0x10;		// GET
		public const int STS_SPAS			= 0x20;		// Spoll
		public const int STS_END			= 0x40;		// END
		public const int STS_REM			= 0x100;	// Remote
		public const int STS_LLO			= 0x200;	// LLO
		public const int STS_TLK			= 0x400;	// Talker
		public const int STS_LSN			= 0x800;	// Listener
		public const int STS_ATN			= 0x1000;	// ATN
		public const int STS_SRQ			= 0x2000;	// SRQ
		public const int STS_REN			= 0x4000;	// REN
		//------------------------------------------------------------------
		// GPIB֘Ap[^w͈
		//-------------------------------------------------------------------
		public const short ADDR_MIN			= 0;		// ŏGPIBڽ
		public const short ADDR_MAX			= 30;		// ő    "
		public const int TIMEOUT_DEFAULT	= 2000;		// ѱ̫
		public const int TIMEOUT_MAX		= 60000;	// ѱčől
		//-------------------------------------------------------------------
		// }`CbZ[W(GPIBR}h)w
		//-------------------------------------------------------------------
		public const byte MLM_LA_0			= 0x20;		// Listener Addr
		public const byte MLM_TA_0			= 0x40;		// Talker Addr
		public const byte MLM_UNL			= 0x3F;		// UNListen
		public const byte MLM_UNT			= 0x5F;		// UNTalk
		public const byte MLM_GTL			= 0x1;		// Go To Local
		public const byte MLM_SDC			= 0x4;		// Select Device Clear
		public const byte MLM_GETRG			= 0x8;		// Group Execute Trigger
		public const byte MLM_LLO			= 0x11;		// Local Lock Out
		public const byte MLM_DCL			= 0x14;		// Device Clear
		public const byte MLM_SPE			= 0x18;		// Serial Poll Enable
		public const byte MLM_SPD			= 0x19;		// Serial Poll Disable
		public const byte MLM_PPC			= 0x5;		// Parallel Poll Config
		public const byte MLM_PPE			= 0x60;		// Parallel Poll Enable
		public const byte MLM_PPZ			= 0x70;		// Parallel Poll Disable
		public const byte MLM_PPU			= 0x15;		// Parallel Poll Unconfig
		public const byte MLM_TCT			= 0x9;		// Take Control (XXX)
		//-------------------------------------------------------------------
		// GPIB샂[hw
		//-------------------------------------------------------------------
		public const short MODE_SYSCON		= 1;		// Ѻ۰Ӱ
		public const short MODE_TLKLSN		= 0;		// İؽӰ
		public const short MODE_SLAVE		= 0;		// ڰӰ
		public const short MODE_CON			= 2;		// ۰Ӱ(gps)
		public const short MODE_MASTER		= 2;		// ϽӰ(gps)
		//-------------------------------------------------------------------
		// f~^[hw
		//-------------------------------------------------------------------
		public const short DELIM_CRLF		= 1;		// CR + LF(̫)
		public const short DELIM_CR			= 2;		// CR
		public const short DELIM_LF			= 3;		// LF
		public const short DELIM_NO			= 0;		// NOTHING
		//-------------------------------------------------------------------
		// dnh[hw
		//-------------------------------------------------------------------
		public const short EOI_ON			= 1;		// t(̫)
		public const short EOI_OFF			= 0;		// Ȃ
		//-------------------------------------------------------------------
		// ̑̒萔
		//-------------------------------------------------------------------
		public const short SLOT_AUTO		= -1;
		public const int MAX_SLOTS			= 16;		// foCX͂PU܂Ŏg܂
		//-------------------------------------------------------------------
		// \[X\̊evf̍ő吔
		//-------------------------------------------------------------------
		public const int MAX_MEM			= 9;
		public const int MAX_IO				= 20;
		public const int MAX_IRQ			= 7;
		public const int MAX_DMA			= 7;
		public const int MAX_RSV			= 3;

		[StructLayout(LayoutKind.Sequential)]
		public struct Resource
		{
			public int		dwNumMemWindows;
			[MarshalAs(UnmanagedType.ByValArray,SizeConst = MAX_MEM)]
			public int[]	dwMemBase;
			[MarshalAs(UnmanagedType.ByValArray,SizeConst = MAX_MEM)]
			public int[]	dwMemLength;
			[MarshalAs(UnmanagedType.ByValArray,SizeConst = MAX_MEM)]
			public int[]	dwMemAttrib;
			public int		dwNumIOPorts;
			[MarshalAs(UnmanagedType.ByValArray,SizeConst = MAX_IO)]
			public int[]	dwIOPortBase;
			[MarshalAs(UnmanagedType.ByValArray,SizeConst = MAX_IO)]
			public int[]	dwIOPortLength;
			public int		dwNumIRQs;
			[MarshalAs(UnmanagedType.ByValArray,SizeConst = MAX_IRQ)]
			public int[]	dwIRQRegisters;
			[MarshalAs(UnmanagedType.ByValArray,SizeConst = MAX_IRQ)]
			public int[]	dwIRQAttrib;
			public int		dwNumDMAs;
			[MarshalAs(UnmanagedType.ByValArray,SizeConst = MAX_DMA)]
			public int[]	dwDMALst;
			[MarshalAs(UnmanagedType.ByValArray,SizeConst = MAX_DMA)]
			public int[]	dwDMAAttrib;
			[MarshalAs(UnmanagedType.ByValArray,SizeConst = MAX_RSV)]
			public int[]	dwReserved1;
		}
	
		//-------------------------------------------------------------------
		// API Functions
		//-------------------------------------------------------------------
		[DllImport("apci01.dll")]
		public extern static        int  Apci01GetLastError( short wLogSlot );
		[DllImport("apci01.dll")]
		public extern static        int  Apci01GetStatus( short wLogSlot );
		[DllImport("apci01.dll")]
		public extern static unsafe bool Apci01GetVersion( int* pdwDllVersion, int* pdwDriverVersion );
		[DllImport("apci01.dll")]
		public extern static unsafe bool Apci01Create( short* pwLogSlot );
		[DllImport("apci01.dll")]
		public extern static        bool Apci01Close( short wLogSlot );
		[DllImport("apci01.dll")]
		public extern static unsafe bool Apci01GetResource( short wLogSlot, ref Resource pResInfo );
		[DllImport("apci01.dll")]
		public extern static        bool Apci01Init( short wLogSlot, short wGpibAddr, short wGpibMode, int dwFifoSize );
		[DllImport("apci01.dll")]
		public extern static        bool Apci01SetTime( short wLogSlot, int dwTimeoutCnt );
		[DllImport("apci01.dll")]
		public extern static        bool Apci01SetEos( short wLogSlot, short wDlmMode, short wEoiMode );
		[DllImport("apci01.dll")]
		public extern static unsafe bool Apci01SendCmd( short wLogSlot, byte* pSendBuf, int dwSendBytes);
		[DllImport("apci01.dll")]
		public extern static        bool Apci01Ifc( short wLogSlot );
		[DllImport("apci01.dll")]
		public extern static        bool Apci01Ren( short wLogSlot, short wRenLine );
		[DllImport("apci01.dll")]
		public extern static        bool Apci01Dcl( short wLogSlot );
		[DllImport("apci01.dll")]
		public extern static        bool Apci01Sdc( short wLogSlot, short wLsnAdrs );
		[DllImport("apci01.dll")]
		public extern static unsafe bool Apci01SendDataCN( short wLogSlot, short* pwLsnAdrsList, short wLsnAdrsCnt, byte* pbSendBuff, int dwDataCnt );
		[DllImport("apci01.dll")]
		public extern static unsafe bool Apci01SendDataC( short wLogSlot, short wLsnAdrs, byte* pbSendBuff, int dwDataCnt );
		[DllImport("apci01.dll")]
		public extern static unsafe bool Apci01SendDataS( short wLogSlot, byte* pbSendBuff, int dwDataCnt );
		[DllImport("apci01.dll")]
		public extern static unsafe bool Apci01RecvDataC( short wLogSlot, short wTlkAdrs, byte* pbRecvBuff, int* pdwDataCnt );
		[DllImport("apci01.dll")]
		public extern static unsafe bool Apci01RecvDataS( short wLogSlot, byte* pbRecvBuff, int* pdwDataCnt );
		[DllImport("apci01.dll")]
		public extern static unsafe bool Apci01TransDataN( short wLogSlot, short wTlkAdrs, short* pwLsnAdrsList, short wLsnAdrsCnt );
		[DllImport("apci01.dll")]
		public extern static        bool Apci01TransData( short wLogSlot, short wTlkAdrs, short wLsnAdrs );
		[DllImport("apci01.dll")]
		public extern static        bool Apci01SetSrqLine( short wLogSlot, byte bStsByte );
		[DllImport("apci01.dll")]
		public extern static unsafe bool Apci01GetSrqLine( short wLogSlot, short* pwSrqLine );
		[DllImport("apci01.dll")]
		public extern static unsafe bool Apci01Spoll( short wLogSlot, short wPollAdrs, byte* pbStsByte );
		[DllImport("apci01.dll")]
		public extern static unsafe bool Apci01Ppoll( short wLogSlot, byte* pbDioLine );
		[DllImport("apci01.dll")]
		public extern static        bool Apci01PpollConfig( short wLogSlot, short wLsnAdrs, byte bDioLine, byte bSbit );
		[DllImport("apci01.dll")]
		public extern static        bool Apci01PpollUnConfig( short wLogSlot, short wLsnAdrs );
		[DllImport("apci01.dll")]
		public extern static        bool Apci01PpollUnConfigAll( short wLogSlot );
		[DllImport("apci01.dll")]
		public extern static        bool Apci01PpollRespModeSet( short wLogSlot, short wPMode );
		[DllImport("apci01.dll")]
		public extern static unsafe bool Apci01GetSwitchValue(short wLogSlot,int* pdwSwitchValue);
		[DllImport("apci01.dll")]
		public extern static unsafe bool Apci01GetDipSwitch(short wLogSlot, byte* pbDipsw);

		//===================================================================
		//   		G[R[h擾
		//   		wLogSlot		foCX
		// ߂l		G[R[h
		//===================================================================
		public int GetLastError( short wLogSlot )
		{
			try
			{
				return Apci01GetLastError(wLogSlot);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "aPCI-G01 Error", 
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return mErrWradll;
			}
		}
		//===================================================================
		//   		GPIBXe[^X̎擾
		//   		wLogSlot		foCX
		// ߂l		Xe[^X
		//===================================================================
		public int GetStatus( short wLogSlot )
		{
			try
			{
				return Apci01GetStatus(wLogSlot);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "aPCI-G01 Error", 
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return ERR_WRAPDLL;
			}
		}
		//============================================================================
		// 		DLL,޲ײްްޮݔԍ擾
		// 		pdwDllVersion		DLLްޮݔԍi[̈ւ߲
		//			pdwDriverVersion	޲ײްްޮݔԍi[̈ւ߲
		// ߂l 	 	true
		//			s 	false
		//============================================================================
		public unsafe bool GetVersion( int* pdwDllVersion, int* pdwDriverVersion )
		{
			try
			{
				return Apci01GetVersion(pdwDllVersion, pdwDriverVersion);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "aPCI-G01 Error", 
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}

		//============================================================================
		// 		޲̎gp錾
		// 		pwLogSlot		gp޲̘_Ĕԍi[߲
		// ߂l 	 	true
		//			s 	false
		//============================================================================
		public unsafe bool Create( short* pwLogSlot )
		{
			try
			{
				return Apci01Create(pwLogSlot);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "aPCI-G01 Error", 
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}

		//============================================================================
		// 		޲J
		// 		wLogSlot		޲̘_Ĕԍ
		// ߂l 	 	true
		//			s 	false
		//============================================================================
		public bool Close( short wLogSlot )
		{
			try
			{
				return Apci01Close(wLogSlot);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "aPCI-G01 Error", 
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}

		//============================================================================
		// 		w޲ؿ擾
		// 		wLogSlot		޲̘_Ĕԍ
		//			pResInfo		ؿi[\߲̂
		// ߂l 	 	true
		//			s 	false
		//============================================================================
		public unsafe bool GetResource( short wLogSlot, ref Resource pResInfo )
		{
			try
			{
				return Apci01GetResource(wLogSlot, ref pResInfo);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "aPCI-G01 Error", 
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}

		//============================================================================
		// 		
		// 		wLogSlot		޲̘_Ĕԍ
		//			wGpibAddr   	g GP-IB AhX
		//			wGpibMode		g GP-IB 샂[h
		//			dwFifoSize		Mobt@̑傫
		// ߂l 	 	true
		//			s 	false
		//============================================================================
		public bool Init( short wLogSlot, short wGpibAddr, short wGpibMode, int dwFifoSize )
		{
			try
			{
				return Apci01Init(wLogSlot, wGpibAddr, wGpibMode, dwFifoSize);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "aPCI-G01 Error", 
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}

		//============================================================================
		// 		GPIBѱĐݒ
		// 		wLogSlot		޲̘_Ĕԍ
		//			dwTimeoutCnt  	^CAEglBPʂ̓~b0`60000܂ŁB
		// ߂l 	 	true
		//			s 	false
		//============================================================================
		public bool SetTime( short wLogSlot, int dwTimeoutCnt )
		{
			try
			{
				return Apci01SetTime(wLogSlot, dwTimeoutCnt);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "aPCI-G01 Error", 
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}

		//============================================================================
		// 		EOIݒ
		// 		wLogSlot		޲̘_Ĕԍ
		//			wDlmMode    	f~^w
		//			wEoiMode    	dnh̎gp܂͕sgpw
		// ߂l 	 	true
		//			s 	false
		//============================================================================
		public bool SetEos( short wLogSlot, short wDlmMode, short wEoiMode )
		{
			try
			{
				return Apci01SetEos(wLogSlot, wDlmMode, wEoiMode);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "aPCI-G01 Error", 
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}

		//============================================================================
		// 		GPIBޑM(۰חp)
		// 		wLogSlot		޲̘_Ĕԍ
		//			paSendBuf   	MR}hobt@̃AhX
		//			dwSendBytes		MׂR}h̃oCg
		// ߂l 	 	true
		//			s 	false
		//============================================================================
		public unsafe bool SendCmd( short wLogSlot, byte* paSendBuf, int dwSendBytes )
		{
			try
			{
				return Apci01SendCmd(wLogSlot, paSendBuf, dwSendBytes);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "aPCI-G01 Error", 
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}

		//============================================================================
		// 		IFCM(۰חp)
		// 		wLogSlot		޲̘_Ĕԍ
		// ߂l 	 	true
		//			s 	false
		//============================================================================
		public bool Ifc( short wLogSlot )
		{
			try
			{
				return Apci01Ifc(wLogSlot);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "aPCI-G01 Error", 
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}

		//============================================================================
		// 		RENײ݂̐ݒ(۰חp)
		// 		wLogSlot		޲̘_Ĕԍ
		//			wRenLine		1(^)/0(U)
		// ߂l 	 	true
		//			s 	false
		//============================================================================
		public bool Ren( short wLogSlot, short wRenLine )
		{
			try
			{
				return Apci01Ren(wLogSlot, wRenLine);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "aPCI-G01 Error", 
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}

		//============================================================================
		// 		DCLM(۰חp)
		// 		wLogSlot		޲̘_Ĕԍ
		// ߂l	 	true
		//			s 	false
		//============================================================================
		public bool Dcl( short wLogSlot )
		{
			try
			{
				return Apci01Dcl(wLogSlot);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "aPCI-G01 Error", 
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}

		//============================================================================
		// 		w@ւSDCM(۰חp)
		// 		wLogSlot		޲̘_Ĕԍ
		//			wLsnAdrs		XiAhX
		// ߂l 	 	true
		//			s 	false
		//============================================================================
		public bool Sdc( short wLogSlot, short wLsnAdrs )
		{
			try
			{
				return Apci01Sdc(wLogSlot, wLsnAdrs);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "aPCI-G01 Error", 
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}

		//============================================================================
		// 		̎w@ւްM(۰חp)
		// 		wLogSlot		޲̘_Ĕԍ
		//			pwLsnAdrsList 	XiAhXXg̃AhX
		//			wLsnAdrsCnt		XiAhX̐
		//			pbSendBuff		Mf[^obt@̃AhX
		//			dwDataCnt		Mf[^
		// ߂l 	 	true
		//			s 	false
		//============================================================================
		public unsafe bool SendDataCN( short wLogSlot, short* pwLsnAdrsList, short wLsnAdrsCnt, byte* pbSendBuff, int dwDataCnt )
		{
			try
			{
				return Apci01SendDataCN(wLogSlot, pwLsnAdrsList, wLsnAdrsCnt, pbSendBuff, dwDataCnt);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "aPCI-G01 Error", 
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}

		//============================================================================
		// 		w@ւްM(۰חp)
		// 		wLogSlot		޲̘_Ĕԍ
		//			wLsnAdrs		XiAhX
		//			pbSendBuff		Mf[^obt@̃AhX
		//			dwDataCnt   	Mf[^
		// ߂l 	 	true
		//			s 	false
		//============================================================================
		public unsafe bool SendDataC( short wLogSlot, short wLsnAdrs, byte* pbSendBuff, int dwDataCnt )
		{
			try
			{
				return Apci01SendDataC(wLogSlot, wLsnAdrs, pbSendBuff, dwDataCnt);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "aPCI-G01 Error", 
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}

		//============================================================================
		// 		ްM(ڰޗp)
		// 		wLogSlot		޲̘_Ĕԍ
		//			pbSendBuff		Mf[^obt@̃AhX
		//			dwDataCnt		Mf[^
		// ߂l 	 	true
		//			s 	false
		//============================================================================
		public unsafe bool SendDataS( short wLogSlot, byte* pbSendBuff, int dwDataCnt )
		{
			try
			{
				return Apci01SendDataS(wLogSlot, pbSendBuff, dwDataCnt);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "aPCI-G01 Error", 
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}

		//============================================================================
		// 		w@킩ްM(۰חp)
		// 		wLogSlot		޲̘_Ĕԍ
		//			wTlkAdrs		g[JAhX
		//			pbRecvBuff		Mf[^obt@̃AhX
		//			pdwDataCnt		Mf[^w肷ϐ̃AhX
		// ߂l 	 	true
		//			s 	false
		//============================================================================
		public unsafe bool RecvDataC( short wLogSlot, short wTlkAdrs, byte* pbRecvBuff, int* pdwDataCnt )
		{
			try
			{
				return Apci01RecvDataC(wLogSlot, wTlkAdrs, pbRecvBuff, pdwDataCnt);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "aPCI-G01 Error", 
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}

		//============================================================================
		// 		ްM(ڰޗp)
		// 		wLogSlot		޲̘_Ĕԍ
		//			pbRecvBuff 		Mf[^obt@̃AhX
		//			pdwDataCnt  	Mf[^w肷ϐ̃AhX
		// ߂l 	 	true
		//			s 	false
		//============================================================================
		public unsafe bool RecvDataS( short wLogSlot, byte* pbRecvBuff, int* pdwDataCnt )
		{
			try
			{
				return Apci01RecvDataS(wLogSlot, pbRecvBuff, pdwDataCnt);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "aPCI-G01 Error", 
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}

		//============================================================================
		// 		@ް](۰חp)
		// 		wLogSlot		޲̘_Ĕԍ
		//			wTlkAdrs      	g[JAhX
		//			pwLsnAdrsList	XiAhXXg̃AhX
		//			wLsnAdrsCnt		XiAhX̐
		// ߂l 	 	true
		//			s 	false
		//============================================================================
		public unsafe bool TransDataN( short wLogSlot, short wTlkAdrs, short* pwLsnAdrsList, short wLsnAdrsCnt )
		{
			try
			{
				return Apci01TransDataN(wLogSlot, wTlkAdrs, pwLsnAdrsList, wLsnAdrsCnt);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "aPCI-G01 Error", 
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}

		//============================================================================
		// 		@ް](۰חp)
		// 		wLogSlot		޲̘_Ĕԍ
		//			wTlkAdrs		g[JAhX
		//			wLsnAdrs		XiAhX
		// ߂l 	 	true
		//			s 	false
		//============================================================================
		public bool TransData( short wLogSlot, short wTlkAdrs, short wLsnAdrs )
		{
			try
			{
				return Apci01TransData(wLogSlot, wTlkAdrs, wLsnAdrs);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "aPCI-G01 Error", 
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}

		//============================================================================
		// 		SRQײ݂ƽð޲Đݒ(ڰޗp)
		// 		wLogSlot		޲̘_Ĕԍ
		//			bStsByte		Xe[^XoCgl
		// ߂l 	 	true
		//			s 	false
		//============================================================================
		public bool SetSrqLine( short wLogSlot, byte bStsByte )
		{
			try
			{
				return Apci01SetSrqLine(wLogSlot, bStsByte);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "aPCI-G01 Error", 
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}

		//============================================================================
		// 		SRQײ݂̏Ԕ(۰חp)
		// 		wLogSlot		޲̘_Ĕԍ
		//			pwSrqLine		rqpCԂi[ϐ̃AhX
		// ߂l 	 	true
		//			s 	false
		//============================================================================
		public unsafe bool GetSrqLine( short wLogSlot, short* pwSrqLine )
		{
			try
			{
				return Apci01GetSrqLine(wLogSlot, pwSrqLine);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "aPCI-G01 Error", 
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}

		//============================================================================
		// 		رَ߰s(۰חp)
		// 		wLogSlot		޲̘_Ĕԍ
		//			wPollAdrs		|[ÕAhX
		//			pbStsByte		Xe[^XoCgi[ϐ̃AhX
		// ߂l 	 	true
		//			s 	false
		//============================================================================
		public unsafe bool Spoll( short wLogSlot, short wPollAdrs, byte* pbStsByte )
		{
			try
			{
				return Apci01Spoll(wLogSlot, wPollAdrs, pbStsByte);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "aPCI-G01 Error", 
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}

		//============================================================================
		// 		َ߰s(۰חp)
		// 		wLogSlot		޲̘_Ĕԍ
		//			pbDioLine   	chnCi[ϐ̃AhX
		// ߂l 	 	true
		//			s 	false
		//============================================================================
		public unsafe bool Ppoll( short wLogSlot, byte* pbDioLine )
		{
			try
			{
				return Apci01Ppoll(wLogSlot, pbDioLine);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "aPCI-G01 Error", 
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}

		//============================================================================
		// 		ٍ߰\(۰חp)
		// 		wLogSlot		޲̘_Ĕԍ
		//			wLsnAdrs		\@AhX
		//			bDioLine    	@tDIOCԍiO`ṼrbgԍŎwj
		//			bSbit			ZXrbg̎wiO܂͂Pj
		// ߂l 	 	true
		//			s 	false
		//============================================================================
		public bool PpollConfig( short wLogSlot, short wLsnAdrs, byte bDioLine, byte bSbit )
		{
			try
			{
				return Apci01PpollConfig(wLogSlot, wLsnAdrs, bDioLine, bSbit);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "aPCI-G01 Error", 
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}

		//============================================================================
		// 		w@ٍ߰\(۰חp)
		// 		wLogSlot		޲̘_Ĕԍ
		//			wLsnAdrs		\@AhX
		// ߂l 	 	true
		//			s 	false
		//============================================================================
		public bool PpollUnConfig( short wLogSlot, short wLsnAdrs )
		{
			try
			{
				return Apci01PpollUnConfig(wLogSlot, wLsnAdrs);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "aPCI-G01 Error", 
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}

		//============================================================================
		// 		S@ٍ߰\(۰חp)
		// 		wLogSlot		޲̘_Ĕԍ
		// ߂l 	 	true
		//			s 	false
		//============================================================================
		public bool PpollUnConfigAll( short wLogSlot )
		{
			try
			{
				return Apci01PpollUnConfigAll(wLogSlot);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "aPCI-G01 Error", 
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}

		//============================================================================
		// 		߰ىݒ(ڰޗp)
		// 		wLogSlot		޲̘_Ĕԍ
		//			wPMode			p|[ւ̉@
		// ߂l 	 	true
		//			s 	false
		//============================================================================
		public bool PpollRespModeSet( short wLogSlot, short wPMode )
		{
			try
			{
				return Apci01PpollRespModeSet(wLogSlot, wPMode);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "aPCI-G01 Error", 
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}

		//===================================================================
		//   		BSN̒l擾
		//   		wLogSlot		foCX̘_Ĕԍ
		//				pdwSwitchValue	arm̒li[̈ւ̃|C^
		// ߂l 		 	true
		//				s 	false
		//===================================================================
		public unsafe bool GetSwitchValue(short wLogSlot,int* pdwSwitchValue)
		{
			try
			{
				return Apci01GetSwitchValue(wLogSlot, pdwSwitchValue);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "aPCI-G01 Error", 
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}
		//===================================================================
		//   		DIP-SW̒l擾
		//   		wLogSlot		foCX̘_Ĕԍ
		//				pbDipsw			rvli[̈ւ̃|C^
		// ߂l 		 	true
		//				s 	false
		//===================================================================
		public unsafe bool GetDipSwitch(short wLogSlot, byte* pbDipsw)
		{
			try
			{
				return Apci01GetDipSwitch(wLogSlot, pbDipsw);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "aPCI-G01 Error", 
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}
	}
}
