/*============================================================================
//	apci01w.h
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//==========================================================================*/
#pragma once

#include <windows.h>

using namespace System;
using namespace System::ComponentModel;
using namespace System::Collections;
using namespace System::Windows::Forms;
using namespace System::Data;
using namespace System::Drawing;
using namespace System::Threading;
using namespace System::Runtime::InteropServices;

#ifdef MessageBox
#undef MessageBox
#endif

// NX̐錾
__gc public class Apci01w;

__gc public class Apci01w
{
private:
	static int mErrWradll = SUCCESS;	// bp[֐G[

public:
	// őXbg
	static const int	MAX_SLOTS				= 16;

	// _Xbgw
	static const short	SLOT_AUTO				= -1;

	//-------------------------------------------------------------------
	// G[R[h̒`
	//-------------------------------------------------------------------
	static const int	SUCCESS					= 0;		// ُȂiIj
	static const int	ERR_SYSTEM				= 1;		// Windows  GetLastError() R[Ă
															// ɃhCo[hĂȂ\܂
	static const int	ERR_NO_DEVICE			= 2;		// gp\ȃfoCX܂
	static const int	ERR_IN_USE				= 3;		// w̃foCX͎gpł
	static const int	ERR_INVALID_SLOT		= 4;		// Ș_\Pbgł
	static const int	ERR_RESOURCE			= 5;		// \[XG[
	static const int	ERR_INVALID_ARGUMENT	= 6;		// p[^s
	static const int	ERR_NOTINIT				= 7;		// Ă܂B
	static const int	ERR_MODE				= 8;		// GPIB ̃[hG[łB
	static const int	ERR_TIMEOUT				= 9;		// ^CAEg܂B
	static const int	ERR_NOLSN				= 10;		// XiiP[uڑj
	static const int	ERR_BUSY				= 11;		// s
	static const int	ERR_ETC					= 12;		// ̑̃G[
	static const int	ERR_WRAPDLL				= -1;

	//-------------------------------------------------------------------
	// GPIB p[^`
	//-------------------------------------------------------------------

	// GPIBXe[^X擾
	static const int	STS_IFC					= 0x0001;	// IFC
	static const int	STS_DCAS				= 0x0002;	// DeviceClear
	static const int	STS_UNC					= 0x0004;	// Ppoll,TCT etc
	static const int	STS_ERR					= 0x0008;	// Error
	static const int	STS_GET					= 0x0010;	// GET
	static const int	STS_SPAS				= 0x0020;	// Spoll
	static const int	STS_END					= 0x0040;	// END
	static const int	STS_REM					= 0x0100;	// Remote
	static const int	STS_LLO					= 0x0200;	// LLO
	static const int	STS_TLK					= 0x0400;	// Talker
	static const int	STS_LSN					= 0x0800;	// Listener
	static const int	STS_ATN					= 0x1000;	// ATN
	static const int	STS_SRQ					= 0x2000;	// SRQ
	static const int	STS_REN					= 0x4000;	// REN

	// GPIB֘Ap[^w͈
	static const short	ADDR_MIN				= 0;		// ŏGPIBڽ
	static const short	ADDR_MAX				= 30;		// ő    "
	static const int	TIMEOUT_DEFAULT			= 2000L;	// ѱ̫
	static const int	TIMEOUT_MAX				= 60000L;	// ѱčől

	// }`CbZ[W(GPIBR}h)w
	static const char	LA_0					= 0x20;		// Listener Addr
	static const char	TA_0					= 0x40;		// Talker Addr
	static const char	UNL						= 0x3f;		// UNListen
	static const char	UNT						= 0x5F;		// UNTalk
	static const char	GTL						= 0x01;		// Go To Local
	static const char	SDC						= 0x04;		// Select Device Clear
	static const char	LLO						= 0x11;		// Local Lock Out
	static const char	DCL						= 0x14;		// Device Clear
	static const char	SPE						= 0x18;		// Serial Poll Enable
	static const char	SPD						= 0x19;		// Serial Poll Disable
	static const char	PPC						= 0x05;		// Parallel Poll Config
	static const char	PPE						= 0x60;		// Parallel Poll Enable
	static const char	PPZ						= 0x70;		// Parallel Poll Disable
	static const char	PPU						= 0x15;		// Parallel Poll Unconfig
	static const char	TCT						= 0x09;		// Take Control (XXX)

	// GPIB샂[hw
	static const short	MODE_SYSCON				= 1;		// Ѻ۰Ӱ
	static const short	MODE_TLKLSN				= 0;		// İؽӰ
	static const short	MODE_SLAVE				= 0;		// ڰӰ
	static const short	MODE_CON				= 2;		// ۰Ӱ(gps)
	static const short	MODE_MASTER				= 2;		// ϽӰ(gps)

	// f~^[hw
	static const short	DELIM_CRLF				= 1;		// CR + LF(̫)
	static const short	DELIM_CR				= 2;		// CR
	static const short	DELIM_LF				= 3;		// LF
	static const short	DELIM_NO				= 0;		// NOTHING

	// dnh[hw
	static const short	EOI_ON					= 1;		// t(̫)
	static const short	EOI_OFF					= 0;		// Ȃ

	//-------------------------------------------------------------------
	// \[X
	//-------------------------------------------------------------------
	static const int	MAX_MEM					= 9;		// MAX_MEM_REGISTERS
	static const int	MAX_IO					= 20;		// MAX_IO_PORTS
	static const int	MAX_IRQ					= 7;		// MAX_IRQS
	static const int	MAX_DMA					= 7;		// MAX_DMA_CHANNELS
	static const int	MAX_RSV					= 3;		// MAX_Reserved1

	[StructLayout(LayoutKind::Sequential)]
	__gc class Resource
	{
	public:
		Int32 dwNumMemWindows;
		[MarshalAs(UnmanagedType::ByValArray, SizeConst=Apci01w::MAX_MEM)]
		Int32 dwMemBase[];
		[MarshalAs(UnmanagedType::ByValArray, SizeConst=Apci01w::MAX_MEM)]
		Int32 dwMemLength[];
		[MarshalAs(UnmanagedType::ByValArray, SizeConst=Apci01w::MAX_MEM)]
		Int32 dwMemAttrib[];
		Int32 dwNumIOPorts;
		[MarshalAs(UnmanagedType::ByValArray, SizeConst=Apci01w::MAX_IO)]
		Int32 dwIOPortBase[];
		[MarshalAs(UnmanagedType::ByValArray, SizeConst=Apci01w::MAX_IO)]
		Int32 dwIOPortLength[];
		Int32 dwNumIRQs;
		[MarshalAs(UnmanagedType::ByValArray, SizeConst=Apci01w::MAX_IRQ)]
		Int32 dwIRQRegisters[];
		[MarshalAs(UnmanagedType::ByValArray, SizeConst=Apci01w::MAX_IRQ)]
		Int32 dwIRQAttrib[];
		Int32 dwNumDMAs;
		[MarshalAs(UnmanagedType::ByValArray, SizeConst=Apci01w::MAX_DMA)]
		Int32 dwDMALst[];
		[MarshalAs(UnmanagedType::ByValArray, SizeConst=Apci01w::MAX_DMA)]
		Int32 dwDMAAttrib[];
		[MarshalAs(UnmanagedType::ByValArray, SizeConst=Apci01w::MAX_RSV)]
		Int32 dwReserved1[];
	};

	//-------------------------------------------------------------------
	// API
	//-------------------------------------------------------------------
	[DllImport("apci01.dll")]
	static int  Apci01GetLastError( short wLogSlot );
	[DllImport("apci01.dll")]
	static int  Apci01GetStatus( short wLogSlot );
	[DllImport("apci01.dll")]
	static bool Apci01GetVersion( int* pdwDllVersion, int* pdwDriverVersion );
	[DllImport("apci01.dll")]
	static bool Apci01Create( short* pwLogSlot );
	[DllImport("apci01.dll")]
	static bool Apci01Close( short wLogSlot );
	[DllImport("apci01.dll")]
	static bool Apci01GetResource( short wLogSlot, [In][Out] Resource* res );
	[DllImport("apci01.dll")]
	static bool Apci01Init( short wLogSlot, short wGpibAddr, short wGpibMode, int dwFifoSize );
	[DllImport("apci01.dll")]
	static bool Apci01SetTime( short wLogSlot, int dwTimeoutCnt );
	[DllImport("apci01.dll")]
	static bool Apci01SetEos( short wLogSlot, short wDlmMode, short wEoiMode );
	[DllImport("apci01.dll")]
	static bool Apci01SendCmd( short wLogSlot, char* paSendBuf, int dwSendBytes );
	[DllImport("apci01.dll")]
	static bool Apci01Ifc( short wLogSlot );
	[DllImport("apci01.dll")]
	static bool Apci01Ren( short wLogSlot, short wRenLine );
	[DllImport("apci01.dll")]
	static bool Apci01Dcl( short wLogSlot );
	[DllImport("apci01.dll")]
	static bool Apci01Sdc( short wLogSlot, short wLsnAdrs );
	[DllImport("apci01.dll")]
	static bool Apci01SendDataCN( short wLogSlot, short* pwLsnAdrsList, short wLsnAdrsCnt, char* pbSendBuff, int dwDataCnt );
	[DllImport("apci01.dll")]
	static bool Apci01SendDataC( short wLogSlot, short wLsnAdrs, char* pbSendBuff, int dwDataCnt );
	[DllImport("apci01.dll")]
	static bool Apci01SendDataS( short wLogSlot, char* pbSendBuff, int dwDataCnt );
	[DllImport("apci01.dll")]
	static bool Apci01RecvDataC( short wLogSlot, short wTlkAdrs, char* pbRecvBuff, int* pdwDataCnt );
	[DllImport("apci01.dll")]
	static bool Apci01RecvDataS( short wLogSlot, char* pbRecvBuff, int* pdwDataCnt );
	[DllImport("apci01.dll")]
	static bool Apci01TransDataN( short wLogSlot, short wTlkAdrs, short* pwLsnAdrsList, short wLsnAdrsCnt );
	[DllImport("apci01.dll")]
	static bool Apci01TransData( short wLogSlot, short wTlkAdrs, short wLsnAdrs );
	[DllImport("apci01.dll")]
	static bool Apci01SetSrqLine( short wLogSlot, Byte bStsByte );
	[DllImport("apci01.dll")]
	static bool Apci01GetSrqLine( short wLogSlot, short* pwSrqLine );
	[DllImport("apci01.dll")]
	static bool Apci01Spoll( short wLogSlot, short wPollAdrs, Byte* pbStsByte );
	[DllImport("apci01.dll")]
	static bool Apci01Ppoll( short wLogSlot, Byte* pbDioLine );
	[DllImport("apci01.dll")]
	static bool Apci01PpollConfig( short wLogSlot, short wLsnAdrs, Byte bDioLine, Byte bSbit );
	[DllImport("apci01.dll")]
	static bool Apci01PpollUnConfig ( short wLogSlot, short wLsnAdrs );
	[DllImport("apci01.dll")]
	static bool Apci01PpollUnConfigAll( short wLogSlot );
	[DllImport("apci01.dll")]
	static bool Apci01PpollRespModeSet( short wLogSlot, short wPMode );
	[DllImport("apci01.dll")]
	static bool Apci01GetSwitchValue( short wLogSlot, int* pdwSwitchValue );
	[DllImport("apci01.dll")]
	static bool Apci01GetDipSwitch( short wLogSlot, Byte* pbDipsw );


	//===================================================================
	//   		G[R[h擾
	//   		wLogSlot		foCX
	// ߂l		G[R[h
	//===================================================================
	static int GetLastError( short wLogSlot )
	{
		try {
			if (mErrWradll == ERR_WRAPDLL) {	// bp[֐G[Ȃ
				mErrWradll = SUCCESS;			// NA
				return ERR_WRAPDLL;
			} else {
				return Apci01GetLastError(wLogSlot);
			}
		}
		catch (Exception __gc * e) {
			MessageBox::Show(e->Message, S"aPCI-G01 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Stop);
			mErrWradll = SUCCESS;	// bp[֐G[
			return ERR_WRAPDLL;
		}
	}
	//===================================================================
	//   		GPIBXe[^X̎擾
	//   		wLogSlot		foCX
	// ߂l		true	
	//				false	s
	//===================================================================
	static int GetStatus( short wLogSlot )
	{
		try {
			return Apci01GetStatus(wLogSlot);
		}
		catch (Exception __gc * e) {
			System::Windows::Forms::MessageBox::Show(e->Message, S"aPCI-G01 ERROR");
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
	//===================================================================
	//   		o[Wԍ擾
	//   		pdwDllVersion	DLL o[Wi[̈ւ̃|C^
	//				pdwDrvVersion	DRV o[Wi[̈ւ̃|C^
	// ߂l		true	
	//				false	s
	//===================================================================
	static bool GetVersion( int* pdwDllVersion, int* pdwDrvVersion )
	{
		try {
			return Apci01GetVersion(pdwDllVersion, pdwDrvVersion);
		}
		catch (Exception __gc * e) {
			System::Windows::Forms::MessageBox::Show(e->Message, S"aPCI-G01 ERROR");
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
	//===================================================================
	//   		foCX̎gp錾
	//   		pwLogSlot		foCXi[̈ւ̃|C^
	// ߂l		true	
	//				false	s
	//===================================================================
	static bool Create( short* pwLogSlot )
	{
		try {
			return Apci01Create(pwLogSlot);
		}
		catch (Exception __gc * e) {
			System::Windows::Forms::MessageBox::Show(e->Message, S"aPCI-G01 ERROR");
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
	//===================================================================
	//   		foCX̉
	//   		wLogSlot		foCX
	// ߂l		true	
	//				false	s
	//===================================================================
	static bool Close( short wLogSlot )
	{
		try {
			return Apci01Close(wLogSlot);
		}
		catch (Exception __gc * e) {
			System::Windows::Forms::MessageBox::Show(e->Message, S"aPCI-G01 ERROR");
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
	//===================================================================
	//   		\[X擾
	//   		wLogSlot		foCX
	//				res				\[Xi[̈ւ̃|C^
	// ߂l		true	
	//				false	s
	//===================================================================
	static bool GetResource( short wLogSlot, [In][Out] Resource* res )
	{
		try {
			return	Apci01GetResource(wLogSlot, res);
		}
		catch (Exception __gc * e) {
			System::Windows::Forms::MessageBox::Show(e->Message, S"aPCI-G01 ERROR");
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
	//===================================================================
	//   		
	//   		wLogSlot		foCX̘_Ĕԍ
	//				wGpibAddr   	g GP-IB AhX
	//				wGpibMode		g GP-IB 샂[h
	//				dwFifoSize		Mobt@̑傫
	// ߂l 		 	true
	//				s 	false
	//===================================================================
	static bool Init( short wLogSlot, short wGpibAddr, short wGpibMode, int dwFifoSize )
	{
		try {
			return Apci01Init(wLogSlot, wGpibAddr, wGpibMode, dwFifoSize);
		}
		catch (Exception __gc * e) {
			System::Windows::Forms::MessageBox::Show(e->Message, S"aPCI-G01 ERROR");
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
	//===================================================================
	//   		GPIBѱĐݒ
	//   		wLogSlot		foCX̘_Ĕԍ
	//				dwTimeoutCnt  	^CAEglBPʂ̓~b0`60000܂ŁB
	// ߂l 		 	true
	//				s 	false
	//===================================================================
	static bool SetTime( short wLogSlot, int dwTimeoutCnt )
	{
		try {
			return Apci01SetTime(wLogSlot, dwTimeoutCnt);
		}
		catch (Exception __gc * e) {
			System::Windows::Forms::MessageBox::Show(e->Message, S"aPCI-G01 ERROR");
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
	//===================================================================
	//   		EOIݒ
	//   		wLogSlot		foCX̘_Ĕԍ
	//				wDlmMode    	f~^w
	//				wEoiMode    	dnh̎gp܂͕sgpw
	// ߂l 		 	true
	//				s 	false
	//===================================================================
	static bool SetEos( short wLogSlot, short wDlmMode, short wEoiMode )
	{
		try {
			return Apci01SetEos(wLogSlot, wDlmMode, wEoiMode);
		}
		catch (Exception __gc * e) {
			System::Windows::Forms::MessageBox::Show(e->Message, S"aPCI-G01 ERROR");
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
	//===================================================================
	//   		GPIBޑM(۰חp)
	//   		wLogSlot		foCX̘_Ĕԍ
	//				paSendBuf   	MR}hobt@̃AhX
	//				dwSendBytes		MׂR}h̃oCg
	// ߂l 		 	true
	//				s 	false
	//===================================================================
	static bool SendCmd( short wLogSlot, char* paSendBuf, int dwSendBytes )
	{
		try {
			return Apci01SendCmd(wLogSlot, paSendBuf, dwSendBytes);
		}
		catch (Exception __gc * e) {
			System::Windows::Forms::MessageBox::Show(e->Message, S"aPCI-G01 ERROR");
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
	//===================================================================
	//   		IFCM(۰חp)
	//   		wLogSlot		foCX̘_Ĕԍ
	// ߂l 		 	true
	//				s 	false
	//===================================================================
	static bool Ifc( short wLogSlot )
	{
		try {
			return Apci01Ifc(wLogSlot);
		}
		catch (Exception __gc * e) {
			System::Windows::Forms::MessageBox::Show(e->Message, S"aPCI-G01 ERROR");
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
	//===================================================================
	//   		RENײ݂̐ݒ(۰חp)
	//   		wLogSlot		foCX̘_Ĕԍ
	//				wRenLine		1(^)/0(U)
	// ߂l 		 	true
	//				s 	false
	//===================================================================
	static bool Ren( short wLogSlot, short wRenLine )
	{
		try {
			return Apci01Ren(wLogSlot, wRenLine);
		}
		catch (Exception __gc * e) {
			System::Windows::Forms::MessageBox::Show(e->Message, S"aPCI-G01 ERROR");
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
	//===================================================================
	//   		DCLM(۰חp)
	//   		wLogSlot		foCX̘_Ĕԍ
	// ߂l		 	true
	//				s 	false
	//===================================================================
	static bool Dcl( short wLogSlot )
	{
		try {
			return Apci01Dcl(wLogSlot);
		}
		catch (Exception __gc * e) {
			System::Windows::Forms::MessageBox::Show(e->Message, S"aPCI-G01 ERROR");
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
	//===================================================================
	//   		w@ւSDCM(۰חp)
	//   		wLogSlot		foCX̘_Ĕԍ
	//				wLsnAdrs		XiAhX
	// ߂l 		 	true
	//				s 	false
	//===================================================================
	static bool Sdc( short wLogSlot, short wLsnAdrs )
	{
		try {
			return Apci01Sdc(wLogSlot, wLsnAdrs);
		}
		catch (Exception __gc * e) {
			System::Windows::Forms::MessageBox::Show(e->Message, S"aPCI-G01 ERROR");
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
	//===================================================================
	//   		̎w@ւްM(۰חp)
	//   		wLogSlot		foCX̘_Ĕԍ
	//				pwLsnAdrsList 	XiAhXXg̃AhX
	//				wLsnAdrsCnt		XiAhX̐
	//				pbSendBuff		Mf[^obt@̃AhX
	//				dwDataCnt		Mf[^
	// ߂l 		 	true
	//				s 	false
	//===================================================================
	static bool SendDataCN( short wLogSlot, short* pwLsnAdrsList, short wLsnAdrsCnt, char* pbSendBuff, int dwDataCnt )
	{
		try {
			return Apci01SendDataCN(wLogSlot, pwLsnAdrsList, wLsnAdrsCnt, pbSendBuff, dwDataCnt);
		}
		catch (Exception __gc * e) {
			System::Windows::Forms::MessageBox::Show(e->Message, S"aPCI-G01 ERROR");
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
	//===================================================================
	//   		w@ւްM(۰חp)
	//   		wLogSlot		foCX̘_Ĕԍ
	//				wLsnAdrs		XiAhX
	//				pbSendBuff		Mf[^obt@̃AhX
	//				dwDataCnt   	Mf[^
	// ߂l 		 	true
	//				s 	false
	//===================================================================
	static bool SendDataC( short wLogSlot, short wLsnAdrs, char* pbSendBuff, int dwDataCnt )
	{
		try {
			return Apci01SendDataC(wLogSlot, wLsnAdrs, pbSendBuff, dwDataCnt);
		}
		catch (Exception __gc * e) {
			System::Windows::Forms::MessageBox::Show(e->Message, S"aPCI-G01 ERROR");
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
	//===================================================================
	//   		ްM(ڰޗp)
	//   		wLogSlot		foCX̘_Ĕԍ
	//				pbSendBuff		Mf[^obt@̃AhX
	//				dwDataCnt		Mf[^
	// ߂l 		 	true
	//				s 	false
	//===================================================================
	static bool SendDataS( short wLogSlot, char* pbSendBuff, int dwDataCnt )
	{
		try {
			return Apci01SendDataS(wLogSlot, pbSendBuff, dwDataCnt);
		}
		catch (Exception __gc * e) {
			System::Windows::Forms::MessageBox::Show(e->Message, S"aPCI-G01 ERROR");
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
	//===================================================================
	//   		w@킩ްM(۰חp)
	//   		wLogSlot		foCX̘_Ĕԍ
	//				wTlkAdrs		g[JAhX
	//				pbRecvBuff		Mf[^obt@̃AhX
	//				pdwDataCnt		Mf[^w肷ϐ̃AhX
	// ߂l 		 	true
	//				s 	false
	//===================================================================
	static bool RecvDataC( short wLogSlot, short wTlkAdrs, char* pbRecvBuff, int* pdwDataCnt )
	{
		try {
			return Apci01RecvDataC(wLogSlot, wTlkAdrs, pbRecvBuff, pdwDataCnt);
		}
		catch (Exception __gc * e) {
			System::Windows::Forms::MessageBox::Show(e->Message, S"aPCI-G01 ERROR");
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
	//===================================================================
	//   		ްM(ڰޗp)
	//   		wLogSlot		foCX̘_Ĕԍ
	//				pbRecvBuff 		Mf[^obt@̃AhX
	//				pdwDataCnt  	Mf[^w肷ϐ̃AhX
	// ߂l 		 	true
	//				s 	false
	//===================================================================
	static bool RecvDataS( short wLogSlot, char* pbRecvBuff, int* pdwDataCnt )
	{
		try {
			return Apci01RecvDataS(wLogSlot, pbRecvBuff, pdwDataCnt);
		}
		catch (Exception __gc * e) {
			System::Windows::Forms::MessageBox::Show(e->Message, S"aPCI-G01 ERROR");
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
	//===================================================================
	//   		@ް](۰חp)
	//   		wLogSlot		foCX̘_Ĕԍ
	//				wTlkAdrs      	g[JAhX
	//				pwLsnAdrsList	XiAhXXg̃AhX
	//				wLsnAdrsCnt		XiAhX̐
	// ߂l 		 	true
	//				s 	false
	//===================================================================
	static bool TransDataN( short wLogSlot, short wTlkAdrs, short* pwLsnAdrsList, short wLsnAdrsCnt )
	{
		try {
			return Apci01TransDataN(wLogSlot, wTlkAdrs, pwLsnAdrsList, wLsnAdrsCnt);
		}
		catch (Exception __gc * e) {
			System::Windows::Forms::MessageBox::Show(e->Message, S"aPCI-G01 ERROR");
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
	//===================================================================
	//   		@ް](۰חp)
	//   		wLogSlot		foCX̘_Ĕԍ
	//				wTlkAdrs		g[JAhX
	//				wLsnAdrs		XiAhX
	// ߂l 		 	true
	//				s 	false
	//===================================================================
	static bool TransData( short wLogSlot, short wTlkAdrs, short wLsnAdrs )
	{
		try {
			return Apci01TransData(wLogSlot, wTlkAdrs, wLsnAdrs);
		}
		catch (Exception __gc * e) {
			System::Windows::Forms::MessageBox::Show(e->Message, S"aPCI-G01 ERROR");
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
	//===================================================================
	//   		SRQײ݂ƽð޲Đݒ(ڰޗp)
	//   		wLogSlot		foCX̘_Ĕԍ
	//				bStsByte		Xe[^XoCgl
	// ߂l 		 	true
	//				s 	false
	//===================================================================
	static bool SetSrqLine( short wLogSlot, Byte bStsByte )
	{
		try {
			return Apci01SetSrqLine(wLogSlot, bStsByte);
		}
		catch (Exception __gc * e) {
			System::Windows::Forms::MessageBox::Show(e->Message, S"aPCI-G01 ERROR");
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
	//===================================================================
	//   		SRQײ݂̏Ԕ(۰חp)
	//   		wLogSlot		foCX̘_Ĕԍ
	//				pwSrqLine		rqpCԂi[ϐ̃AhX
	// ߂l 		 	true
	//				s 	false
	//===================================================================
	static bool GetSrqLine( short wLogSlot, short* pwSrqLine )
	{
		try {
			return Apci01GetSrqLine(wLogSlot, pwSrqLine);
		}
		catch (Exception __gc * e) {
			System::Windows::Forms::MessageBox::Show(e->Message, S"aPCI-G01 ERROR");
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
	//===================================================================
	//   		رَ߰s(۰חp)
	//   		wLogSlot		foCX̘_Ĕԍ
	//				wPollAdrs		|[ÕAhX
	//				pbStsByte		Xe[^XoCgi[ϐ̃AhX
	// ߂l 		 	true
	//				s 	false
	//===================================================================
	static bool Spoll( short wLogSlot, short wPollAdrs, Byte* pbStsByte )
	{
		try {
			return Apci01Spoll(wLogSlot, wPollAdrs, pbStsByte);
		}
		catch (Exception __gc * e) {
			System::Windows::Forms::MessageBox::Show(e->Message, S"aPCI-G01 ERROR");
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
	//===================================================================
	//   		َ߰s(۰חp)
	//   		wLogSlot		foCX̘_Ĕԍ
	//				pbDioLine   	chnCi[ϐ̃AhX
	// ߂l 		 	true
	//				s 	false
	//===================================================================
	static bool Ppoll( short wLogSlot, Byte* pbDioLine )
	{
		try {
			return Apci01Ppoll(wLogSlot, pbDioLine);
		}
		catch (Exception __gc * e) {
			System::Windows::Forms::MessageBox::Show(e->Message, S"aPCI-G01 ERROR");
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
	//===================================================================
	//   		ٍ߰\(۰חp)
	//   		wLogSlot		foCX̘_Ĕԍ
	//				wLsnAdrs		\@AhX
	//				bDioLine    	@tDIOCԍiO`ṼrbgԍŎwj
	//				bSbit			ZXrbg̎wiO܂͂Pj
	// ߂l 		 	true
	//				s 	false
	//===================================================================
	static bool PpollConfig( short wLogSlot, short wLsnAdrs, Byte bDioLine, Byte bSbit )
	{
		try {
			return Apci01PpollConfig(wLogSlot, wLsnAdrs, bDioLine, bSbit);
		}
		catch (Exception __gc * e) {
			System::Windows::Forms::MessageBox::Show(e->Message, S"aPCI-G01 ERROR");
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
	//===================================================================
	//   		w@ٍ߰\(۰חp)
	//   		wLogSlot		foCX̘_Ĕԍ
	//				wLsnAdrs		\@AhX
	// ߂l 		 	true
	//				s 	false
	//===================================================================
	static bool PpollUnConfig( short wLogSlot, short wLsnAdrs )
	{
		try {
			return Apci01PpollUnConfig(wLogSlot, wLsnAdrs);
		}
		catch (Exception __gc * e) {
			System::Windows::Forms::MessageBox::Show(e->Message, S"aPCI-G01 ERROR");
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
	//===================================================================
	//   		S@ٍ߰\(۰חp)
	//   		wLogSlot		foCX̘_Ĕԍ
	// ߂l 		 	true
	//				s 	false
	//===================================================================
	static bool PpollUnConfigAll( short wLogSlot )
	{
		try {
			return Apci01PpollUnConfigAll(wLogSlot);
		}
		catch (Exception __gc * e) {
			System::Windows::Forms::MessageBox::Show(e->Message, S"aPCI-G01 ERROR");
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
	//===================================================================
	//   		߰ىݒ(ڰޗp)
	//   		wLogSlot		foCX̘_Ĕԍ
	//				wPMode			p|[ւ̉@
	// ߂l 		 	true
	//				s 	false
	//===================================================================
	static bool PpollRespModeSet( short wLogSlot, short wPMode )
	{
		try {
			return Apci01PpollRespModeSet(wLogSlot, wPMode);
		}
		catch (Exception __gc * e) {
			System::Windows::Forms::MessageBox::Show(e->Message, S"aPCI-G01 ERROR");
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
	//===================================================================
	//   		BSN̒l擾
	//   		wLogSlot		foCX̘_Ĕԍ
	//				pdwSwitchValue	BSN̒li[̈ւ̃|C^
	// ߂l 		 	true
	//				s 	false
	//===================================================================
	static bool GetSwitchValue(short wLogSlot,int* pdwSwitchValue)
	{
		try {
			return Apci01GetSwitchValue(wLogSlot, pdwSwitchValue);
		}
		catch (Exception __gc * e) {
			System::Windows::Forms::MessageBox::Show(e->Message, S"aPCI-G01 ERROR");
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
	//===================================================================
	//   		DIP-SW̒l擾
	//   		wLogSlot		foCX̘_Ĕԍ
	//				pbDipsw			SWli[̈ւ̃|C^
	// ߂l 		 	true
	//				s 	false
	//===================================================================
	static bool GetDipSwitch(short wLogSlot, Byte* pbDipsw)
	{
		try {
			return Apci01GetDipSwitch(wLogSlot, pbDipsw);
		}
		catch (Exception __gc * e) {
			System::Windows::Forms::MessageBox::Show(e->Message, S"aPCI-G01 ERROR");
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}


};
