'===================================================================
' Apci01s.vb
'-------------------------------------------------------------------
' aPCI-G01
' Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
'
' ̃\[Xɂ̓bp[֐̎gpႪLqĂ܂
'===================================================================
Option Strict Off
Option Explicit On

Imports System.Runtime.InteropServices

Public Class Apci01s

    Dim G01w As Apci01w

    Private Const MAXBUFF = 4096                ' Mp̃obt@MAX
    Private Const MYADRS = 0                    ' GPIBAhX
    Private Const PRTADRS = 10                  ' GPIBAhX

    Private Sub Apci01s_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim strbuf As String
        Dim dwDllVer As Integer, dwDrvVer As Integer    ' DLL, Drivero[W
        Dim bResult As Boolean                          ' 
        Dim wLogSlot As Short                           ' foCXi[
        Dim wGpibAdrs As Short                          ' haAhX
        Dim wGpibMode As Short                          ' ha[h
        Dim dwFifoSize As Integer                       ' haobt@TCY
        Dim dwTimeout As Integer                        ' ^CAEgl
        Dim ri As Apci01w.Resource                      ' \[X
        Dim SendBuff(MAXBUFF) As Byte                   ' Mp̃obt@
        Dim RecvBuff(MAXBUFF) As Byte                   ' Mp̃obt@
        Dim dwDataCnt As Integer                        ' Mf[^
        Dim wSrqLine As Short                           ' rqpC
        Dim bStsByte As Byte                            ' Xe[^XoCg
        Dim i As Integer                                ' [vpϐ
        Dim dwSwVal As Integer                          ' BSN Switchl

        ' 
        G01w = New Apci01w
        ri = New Apci01w.Resource
        ri.dwMemBase = New Integer(Apci01w.MAX_MEM) {}
        ri.dwMemLength = New Integer(Apci01w.MAX_MEM) {}
        ri.dwMemAttrib = New Integer(Apci01w.MAX_MEM) {}
        ri.dwIOPortBase = New Integer(Apci01w.MAX_IO) {}
        ri.dwIOPortLength = New Integer(Apci01w.MAX_IO) {}
        ri.dwIRQRegisters = New Integer(Apci01w.MAX_IRQ) {}
        ri.dwIRQAttrib = New Integer(Apci01w.MAX_IRQ) {}
        ri.dwDMALst = New Integer(Apci01w.MAX_DMA) {}
        ri.dwDMAAttrib = New Integer(Apci01w.MAX_DMA) {}
        ri.dwReserved1 = New Integer(Apci01w.MAX_RSV) {}

        ' 
        ri.dwNumMemWindows = 0
        For i = 0 To Apci01w.MAX_MEM
            ri.dwMemBase(i) = 0
            ri.dwMemLength(i) = 0
            ri.dwMemAttrib(i) = 0
        Next
        ri.dwNumIOPorts = 0
        For i = 0 To Apci01w.MAX_IO
            ri.dwIOPortBase(i) = 0
            ri.dwIOPortLength(i) = 0
        Next
        ri.dwNumIRQs = 0
        For i = 0 To Apci01w.MAX_IRQ
            ri.dwIRQRegisters(i) = 0
            ri.dwIRQAttrib(i) = 0
        Next
        ri.dwNumDMAs = 0
        For i = 0 To Apci01w.MAX_DMA
            ri.dwDMALst(i) = 0
            ri.dwDMAAttrib(i) = 0
        Next
        For i = 0 To Apci01w.MAX_RSV
            ri.dwReserved1(i) = 0
        Next

        '---------------------------------------------------------------
        ' DLL,DRṼo[Wԍ擾
        '---------------------------------------------------------------
        If G01w.GetVersion(dwDllVer, dwDrvVer) = False Then
            ErrorMessage(Apci01w.SLOT_AUTO)
            Exit Sub
        End If
        strbuf = String.Concat("o[Wԍ擾", vbCrLf, _
                                String.Format("DLL Version: &H{0:x8}", dwDllVer), vbCrLf, _
                                String.Format("Drv Version: &H{0:x8}", dwDrvVer))
        ResultMessage(strbuf)

        '---------------------------------------------------------------
        ' foCX̎gp錾
        '---------------------------------------------------------------
        wLogSlot = Apci01w.SLOT_AUTO    ' gp̃foCXT܂B
        bResult = G01w.Create(wLogSlot) ' ꍇA̎̃foCXi[܂B
        If bResult = False Then
            ErrorMessage(wLogSlot)
            Exit Sub
        End If
        strbuf = String.Concat("foCX̎gp錾", vbCrLf, vbCrLf, _
                                String.Format("LogSlot: {0}", wLogSlot))
        ResultMessage(strbuf)

        '---------------------------------------------------------------
        ' \[X擾
        '---------------------------------------------------------------
        If G01w.GetResource(wLogSlot, ri) = False Then
            ErrorMessage(wLogSlot)
            Exit Sub
        End If
        strbuf = String.Concat("\[X擾", vbCrLf, _
                                String.Format("NumPorts   : &H{0:x}", _
                                                ri.dwIOPortLength(0)), vbCrLf, _
                                String.Format("IO Address : &H{0:x4} - &H{1:x4}", _
                                                ri.dwIOPortBase(0), _
                                                ri.dwIOPortBase(0) + ri.dwIOPortLength(0) - 1), vbCrLf, _
                                String.Format("IRQ        : {0}", ri.dwIRQRegisters(0)))
        ResultMessage(strbuf)

        '---------------------------------------------------------------
        ' BSNXCb`l擾
        '---------------------------------------------------------------
        If G01w.GetSwitchValue(wLogSlot, dwSwVal) = False Then
            ErrorMessage(wLogSlot)
            Exit Sub
        End If
        strbuf = String.Format("BSN : &H{0:x}", dwSwVal)
        ResultMessage(strbuf)

        '---------------------------------------------------------------
        ' aPCI-G01̏
        '---------------------------------------------------------------
        wGpibAdrs = MYADRS                  ' ̂haAhX
        wGpibMode = Apci01w.MODE_SYSCON     ' Rg[ɂȂ
        dwFifoSize = MAXBUFF                ' FIFOobt@TCYw
        If G01w.Init(wLogSlot, wGpibAdrs, wGpibMode, dwFifoSize) = False Then
            ErrorMessage(wLogSlot)
            Exit Sub
        End If
        strbuf = String.Concat("aPCI-G01̏", vbCrLf, vbCrLf, _
                                String.Format("My IB-Address: {0}", wGpibAdrs), vbCrLf, _
                                String.Format("IB-Mode: {0}", wGpibMode), vbCrLf, _
                                String.Format("FifoSize: {0}", dwFifoSize))
        ResultMessage(strbuf)

        '---------------------------------------------------------------
        ' GP-IB ̃^CAEgݒ
        '---------------------------------------------------------------
        dwTimeout = 3000        ' ^CAEgl=Rb
        If G01w.SetTime(wLogSlot, dwTimeout) = False Then
            ErrorMessage(wLogSlot)
            Exit Sub
        End If

        strbuf = String.Concat("GP-IB̃^CAEgݒ", vbCrLf, vbCrLf, _
                                String.Format("Timeout: {0}msec", dwTimeout))
        ResultMessage(strbuf)

        '---------------------------------------------------------------
        ' f~^Ƃdnhݒ
        '---------------------------------------------------------------
        If G01w.SetEos(wLogSlot, Apci01w.DELIM_CRLF, Apci01w.EOI_ON) = False Then
            ErrorMessage(wLogSlot)
            Exit Sub
        End If
        strbuf = String.Concat("f~^EOIݒ", vbCrLf, vbCrLf, _
                                "f~^: CR+LF", vbCrLf, _
                                "EOI: On")
        ResultMessage(strbuf)

        '---------------------------------------------------------------
        ' heb̑MiRg[pj
        '---------------------------------------------------------------
        If G01w.Ifc(wLogSlot) = False Then
            ErrorMessage(wLogSlot)
            Exit Sub
        End If
        ResultMessage("heb̑M")

        '---------------------------------------------------------------
        ' w@ւ̃f[^MiRg[pj
        '---------------------------------------------------------------
        wGpibAdrs = PRTADRS         ' XîhaAhX
        strbuf = "0123456789"       ' Mf[^
        dwDataCnt = strbuf.Length   ' Mf[^
        SendBuff = System.Text.Encoding.GetEncoding(932).GetBytes(strbuf)
        If G01w.SendDataC(wLogSlot, wGpibAdrs, SendBuff, dwDataCnt) = False Then
            ErrorMessage(wLogSlot)
            Exit Sub
        End If
        ResultMessage("w@ւ̃f[^M")

        '---------------------------------------------------------------
        ' w@킩̃f[^MiRg[pj
        '---------------------------------------------------------------
        wGpibAdrs = PRTADRS             ' g[ĴhaAhX
        dwDataCnt = 50                  ' Mf[^
        If G01w.RecvDataC(wLogSlot, wGpibAdrs, RecvBuff, dwDataCnt) = False Then
            ErrorMessage(wLogSlot)
            Exit Sub
        End If
        RecvBuff(dwDataCnt) = 0
        strbuf = String.Concat("w@킩̃f[^M", vbCrLf, vbCrLf, _
                                String.Format("DataCnt: {0}", dwDataCnt), vbCrLf, _
                                "Data   : ", _
                                System.Text.Encoding.GetEncoding(932).GetString(RecvBuff))
        ResultMessage(strbuf)

        '---------------------------------------------------------------
        ' rqpC̏ԔiRg[pj
        '---------------------------------------------------------------
        If G01w.GetSrqLine(wLogSlot, wSrqLine) = False Then
            ErrorMessage(wLogSlot)
            Exit Sub
        End If
        strbuf = String.Concat("rqpC̏Ԕ", vbCrLf, vbCrLf, _
                                String.Format("SRQ line: {0}", wSrqLine))
        ResultMessage(strbuf)

        '---------------------------------------------------------------
        ' VA|[siRg[pj
        '---------------------------------------------------------------
        If wSrqLine = 1 Then
            wGpibAdrs = PRTADRS         ' VA|[haAhX
            If G01w.Spoll(wLogSlot, wGpibAdrs, bStsByte) = False Then
                ErrorMessage(wLogSlot)
                Exit Sub
            End If
            strbuf = String.Concat("VA|[s", vbCrLf, vbCrLf, _
                                    String.Format("STS Byte: &H{0:x2}", bStsByte))
            ResultMessage(strbuf)
        End If

        '---------------------------------------------------------------
        ' foCX̎gpI
        '---------------------------------------------------------------
        If G01w.Close(wLogSlot) = False Then
            ErrorMessage(wLogSlot)
            Exit Sub
        End If
        strbuf = String.Concat("foCX̎gpI", vbCrLf, vbCrLf, _
                                String.Format("LogSlot: {0}", wLogSlot))
        ResultMessage(strbuf)
        Me.Close()
    End Sub

    '===================================================================
    ' ʂ\
    '===================================================================
    Private Sub ResultMessage(ByVal lpszbuf As String)
        MsgBox(lpszbuf, MsgBoxStyle.OkOnly + MsgBoxStyle.Information, Me.Text)
    End Sub

    '===================================================================
    ' G[bZ[W\
    '===================================================================
    Private Sub ErrorMessage(ByVal wLogSlot As Integer)
        Dim dwRes As Long
        Dim szbuf As String

        dwRes = G01w.GetLastError(wLogSlot)
        Select Case dwRes
            Case Apci01w.ERR_WRAPDLL, Apci01w.ERR_SYSTEM
                szbuf = "DLL Load error"
            Case Else                           ' ̑̒l̏ꍇB
                szbuf = String.Concat("aPCI-G01 error", vbCrLf, vbCrLf, _
                                        String.Format("Error code: &H{0:x8}", dwRes))
        End Select
        MsgBox(szbuf, MsgBoxStyle.OKOnly + MsgBoxStyle.Critical, Me.Text)
    End Sub

End Class
