'============================================================================
' Apci01w.bas
'----------------------------------------------------------------------------
' aPCI-G01
' Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
'============================================================================
Option Strict Off
Option Explicit On 

Imports System.Runtime.InteropServices

Public Class Apci01w

    Private mErrWradll As Integer = SUCCESS   ' bp[֐G[

    '-------------------------------------------------------------------
    ' G[R[h
    '-------------------------------------------------------------------
    Public Const SUCCESS As Integer = 0                 ' ُȂiIj
    Public Const ERR_SYSTEM As Integer = 1              ' ɃhCo[hĂȂ\܂
    Public Const ERR_NO_DEVICE As Integer = 2           ' gp\ȃfoCX܂
    Public Const ERR_IN_USE As Integer = 3              ' w̃foCX͑̃vZXŎgpł
    Public Const ERR_INVALID_SLOT As Integer = 4        ' Ș_Xbgԍł
    Public Const ERR_RESOURCE As Integer = 5            ' \[XG[
    Public Const ERR_INVALID_ARGUMENT As Integer = 6    ' sȈw肵܂
    Public Const ERR_NOTINIT As Integer = 7             ' Ă܂B
    Public Const ERR_MODE As Integer = 8                ' GPIB ̃[hG[łB
    Public Const ERR_TIMEOUT As Integer = 9             ' ^CAEg܂B
    Public Const ERR_NOLSN As Integer = 10              ' XiiP[uڑj
    Public Const ERR_BUSY As Integer = 11               ' s
    Public Const ERR_ETC As Integer = 12                ' ̑̃G[
    Public Const ERR_WRAPDLL As Integer = -1            ' bp[֐G[

    '-------------------------------------------------------------------
    ' GPIBXe[^X擾
    '-------------------------------------------------------------------
    Public Const STS_IFC As Integer = &H1               ' IFC
    Public Const STS_DCAS As Integer = &H2              ' DeviceClear
    Public Const STS_UNC As Integer = &H4               ' Ppoll,TCT etc
    Public Const STS_ERR As Integer = &H8               ' Error
    Public Const STS_GET As Integer = &H10              ' GET
    Public Const STS_SPAS As Integer = &H20             ' Spoll
    Public Const STS_END As Integer = &H40              ' END
    Public Const STS_REM As Integer = &H100             ' Remote
    Public Const STS_LLO As Integer = &H200             ' LLO
    Public Const STS_TLK As Integer = &H400             ' Talker
    Public Const STS_LSN As Integer = &H800             ' Listener
    Public Const STS_ATN As Integer = &H1000            ' ATN
    Public Const STS_SRQ As Integer = &H2000            ' SRQ
    Public Const STS_REN As Integer = &H4000            ' REN
    '-------------------------------------------------------------------
    ' GPIB֘Ap[^w͈
    '-------------------------------------------------------------------
    Public Const ADDR_MIN As Short = 0                  ' ŏGPIBڽ
    Public Const ADDR_MAX As Short = 30                 ' ő    "
    Public Const TIMEOUT_DEFAULT As Integer = 2000      ' ѱ̫
    Public Const TIMEOUT_MAX As Integer = 60000         ' ѱčől
    '-------------------------------------------------------------------
    ' }`CbZ[W(GPIBR}h)w
    '-------------------------------------------------------------------
    Public Const MLM_LA_0 As Byte = &H20           ' Listener Addr
    Public Const MLM_TA_0 As Byte = &H40           ' Talker Addr
    Public Const MLM_UNL As Byte = &H3F            ' UNListen
    Public Const MLM_UNT As Byte = &H5F            ' UNTalk
    Public Const MLM_GTL As Byte = &H1             ' Go To Local
    Public Const MLM_SDC As Byte = &H4             ' Select Device Clear
    Public Const MLM_GETRG As Byte = &H8           ' Group Execute Trigger
    Public Const MLM_LLO As Byte = &H11            ' Local Lock Out
    Public Const MLM_DCL As Byte = &H14            ' Device Clear
    Public Const MLM_SPE As Byte = &H18            ' Serial Poll Enable
    Public Const MLM_SPD As Byte = &H19            ' Serial Poll Disable
    Public Const MLM_PPC As Byte = &H5             ' Parallel Poll Config
    Public Const MLM_PPE As Byte = &H60            ' Parallel Poll Enable
    Public Const MLM_PPZ As Byte = &H70            ' Parallel Poll Disable
    Public Const MLM_PPU As Byte = &H15            ' Parallel Poll Unconfig
    Public Const MLM_TCT As Byte = &H9             ' Take Control (XXX)
    '-------------------------------------------------------------------
    ' GPIB샂[hw
    '-------------------------------------------------------------------
    Public Const MODE_SYSCON As Short = 1           ' Ѻ۰Ӱ
    Public Const MODE_TLKLSN As Short = 0           ' İؽӰ
    Public Const MODE_SLAVE As Short = 0            ' ڰӰ
    Public Const MODE_CON As Short = 2              ' ۰Ӱ(gps)
    Public Const MODE_MASTER As Short = 2           ' ϽӰ(gps)
    '-------------------------------------------------------------------
    ' f~^[hw
    '-------------------------------------------------------------------
    Public Const DELIM_CRLF As Short = 1            ' CR + LF(̫)
    Public Const DELIM_CR As Short = 2              ' CR
    Public Const DELIM_LF As Short = 3              ' LF
    Public Const DELIM_NO As Short = 0              ' NOTHING
    '-------------------------------------------------------------------
    ' dnh[hw
    '-------------------------------------------------------------------
    Public Const EOI_ON As Short = 1                ' t(̫)
    Public Const EOI_OFF As Short = 0               ' Ȃ
    '-------------------------------------------------------------------
    ' ̑̒萔
    '-------------------------------------------------------------------
    Public Const SLOT_AUTO As Short = &HFFFFS
    Public Const MAX_SLOTS As Integer = 16          ' foCX͂PU܂Ŏg܂
    '-------------------------------------------------------------------
    ' \[X\̊evf̍ő吔
    '-------------------------------------------------------------------
    Public Const MIN_NUM As Integer = 0
    Public Const MAX_MEM As Integer = 9 - 1
    Public Const MAX_IO As Integer = 20 - 1
    Public Const MAX_IRQ As Integer = 7 - 1
    Public Const MAX_DMA As Integer = 7 - 1
    Public Const MAX_RSV As Integer = 3 - 1

    Structure Resource
        Dim dwNumMemWindows As Integer
        <VBFixedArray(MAX_MEM), _
            System.Runtime.InteropServices.MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_MEM + 1)> Dim dwMemBase() As Integer
        <VBFixedArray(MAX_MEM), _
            System.Runtime.InteropServices.MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_MEM + 1)> Dim dwMemLength() As Integer
        <VBFixedArray(MAX_MEM), _
            System.Runtime.InteropServices.MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_MEM + 1)> Dim dwMemAttrib() As Integer
        Dim dwNumIOPorts As Integer
        <VBFixedArray(MAX_IO), _
            System.Runtime.InteropServices.MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_IO + 1)> Dim dwIOPortBase() As Integer
        <VBFixedArray(MAX_IO), _
            System.Runtime.InteropServices.MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_IO + 1)> Dim dwIOPortLength() As Integer
        Dim dwNumIRQs As Integer
        <VBFixedArray(MAX_IRQ), _
            System.Runtime.InteropServices.MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_IRQ + 1)> Dim dwIRQRegisters() As Integer
        <VBFixedArray(MAX_IRQ), _
            System.Runtime.InteropServices.MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_IRQ + 1)> Dim dwIRQAttrib() As Integer
        Dim dwNumDMAs As Integer
        <VBFixedArray(MAX_DMA), _
            System.Runtime.InteropServices.MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_DMA + 1)> Dim dwDMALst() As Integer
        <VBFixedArray(MAX_DMA), _
            System.Runtime.InteropServices.MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_DMA + 1)> Dim dwDMAAttrib() As Integer
        <VBFixedArray(MAX_RSV), _
            System.Runtime.InteropServices.MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_RSV + 1)> Dim dwReserved1() As Integer
    End Structure

    '-------------------------------------------------------------------
    ' API Functions
    '-------------------------------------------------------------------
    <DllImport("apci01.dll")> _
    Public Shared Function Apci01GetLastError(ByVal wLogSlot As Short) As Integer
    End Function
    <DllImport("apci01.dll")> _
    Public Shared Function Apci01GetStatus(ByVal wLogSlot As Short) As Integer
    End Function
    <DllImport("apci01.dll")> _
    Public Shared Function Apci01GetVersion(ByRef pdwDllVersion As Integer, ByRef pdwDriverVersion As Integer) As Boolean
    End Function
    <DllImport("apci01.dll")> _
    Public Shared Function Apci01Create(ByRef pwLogSlot As Short) As Boolean
    End Function
    <DllImport("apci01.dll")> _
    Public Shared Function Apci01Close(ByVal wLogSlot As Short) As Boolean
    End Function
    <DllImport("apci01.dll")> _
    Public Shared Function Apci01GetResource(ByVal wLogSlot As Short, ByRef pResInfo As Resource) As Boolean
    End Function
    <DllImport("apci01.dll")> _
    Public Shared Function Apci01Init(ByVal wLogSlot As Short, ByVal wGpibAddr As Short, ByVal wGpibMode As Short, ByVal dwFifoSize As Integer) As Boolean
    End Function
    <DllImport("apci01.dll")> _
    Public Shared Function Apci01SetTime(ByVal wLogSlot As Short, ByVal dwTimeoutCnt As Integer) As Boolean
    End Function
    <DllImport("apci01.dll")> _
    Public Shared Function Apci01SetEos(ByVal wLogSlot As Short, ByVal wDlmMode As Short, ByVal wEoiMode As Short) As Boolean
    End Function
    <DllImport("apci01.dll")> _
    Public Shared Function Apci01SendCmd(ByVal wLogSlot As Short, ByRef paSendBuf As Byte, ByVal dwSendBytes As Integer) As Boolean
    End Function
    <DllImport("apci01.dll")> _
    Public Shared Function Apci01Ifc(ByVal wLogSlot As Short) As Boolean
    End Function
    <DllImport("apci01.dll")> _
    Public Shared Function Apci01Ren(ByVal wLogSlot As Short, ByVal wRenLine As Short) As Boolean
    End Function
    <DllImport("apci01.dll")> _
    Public Shared Function Apci01Dcl(ByVal wLogSlot As Short) As Boolean
    End Function
    <DllImport("apci01.dll")> _
    Public Shared Function Apci01Sdc(ByVal wLogSlot As Short, ByVal wLsnAdrs As Short) As Boolean
    End Function
    <DllImport("apci01.dll")> _
    Public Shared Function Apci01SendDataCN(ByVal wLogSlot As Short, ByRef pwLsnAdrsList As Short, ByVal wLsnAdrsCnt As Short, ByRef pbSendBuff As Byte, ByVal dwDataCnt As Integer) As Boolean
    End Function
    <DllImport("apci01.dll")> _
    Public Shared Function Apci01SendDataC(ByVal wLogSlot As Short, ByVal wLsnAdrs As Short, ByRef pbSendBuff As Byte, ByVal dwDataCnt As Integer) As Boolean
    End Function
    <DllImport("apci01.dll")> _
    Public Shared Function Apci01SendDataS(ByVal wLogSlot As Short, ByRef pbSendBuff As Byte, ByVal dwDataCnt As Integer) As Boolean
    End Function
    <DllImport("apci01.dll")> _
    Public Shared Function Apci01RecvDataC(ByVal wLogSlot As Short, ByVal wTlkAdrs As Short, ByRef pbRecvBuff As Byte, ByRef pdwDataCnt As Integer) As Boolean
    End Function
    <DllImport("apci01.dll")> _
    Public Shared Function Apci01RecvDataS(ByVal wLogSlot As Short, ByRef pbRecvBuff As Byte, ByRef pdwDataCnt As Integer) As Boolean
    End Function
    <DllImport("apci01.dll")> _
    Public Shared Function Apci01TransDataN(ByVal wLogSlot As Short, ByVal wTlkAdrs As Short, ByRef pwLsnAdrsList As Short, ByVal wLsnAdrsCnt As Short) As Boolean
    End Function
    <DllImport("apci01.dll")> _
    Public Shared Function Apci01TransData(ByVal wLogSlot As Short, ByVal wTlkAdrs As Short, ByVal wLsnAdrs As Short) As Boolean
    End Function
    <DllImport("apci01.dll")> _
    Public Shared Function Apci01SetSrqLine(ByVal wLogSlot As Short, ByVal bStsByte As Byte) As Boolean
    End Function
    <DllImport("apci01.dll")> _
    Public Shared Function Apci01GetSrqLine(ByVal wLogSlot As Short, ByRef pwSrqLine As Short) As Boolean
    End Function
    <DllImport("apci01.dll")> _
    Public Shared Function Apci01Spoll(ByVal wLogSlot As Short, ByVal wPollAdrs As Short, ByRef pbStsByte As Byte) As Boolean
    End Function
    <DllImport("apci01.dll")> _
    Public Shared Function Apci01Ppoll(ByVal wLogSlot As Short, ByRef pbDioLine As Byte) As Boolean
    End Function
    <DllImport("apci01.dll")> _
    Public Shared Function Apci01PpollConfig(ByVal wLogSlot As Short, ByVal wLsnAdrs As Short, ByVal bDioLine As Byte, ByVal bSbit As Byte) As Boolean
    End Function
    <DllImport("apci01.dll")> _
    Public Shared Function Apci01PpollUnConfig(ByVal wLogSlot As Short, ByVal wLsnAdrs As Short) As Boolean
    End Function
    <DllImport("apci01.dll")> _
    Public Shared Function Apci01PpollUnConfigAll(ByVal wLogSlot As Short) As Boolean
    End Function
    <DllImport("apci01.dll")> _
    Public Shared Function Apci01PpollRespModeSet(ByVal wLogSlot As Short, ByVal wPMode As Short) As Boolean
    End Function
    <DllImport("apci01.dll")> _
    Public Shared Function Apci01GetSwitchValue(ByVal wLogSlot As Short, ByRef pdwSwitchValue As Integer) As Boolean
    End Function
    <DllImport("apci01.dll")> _
    Public Shared Function Apci01GetDipSwitch(ByVal wLogSlot As Short, ByRef pbDipsw As Byte) As Boolean
    End Function


    '============================================================================
    '           װނ̎擾
    '           wLogSlot                foCX̘_Xbgԍ
    ' ߂l        װ
    '============================================================================
    Function GetLastError(ByVal wLogSlot As Short) As Integer
        Try
            If mErrWradll = ERR_WRAPDLL Then    ' bp[֐G[Ȃ
                mErrWradll = SUCCESS            ' NA
                GetLastError = ERR_WRAPDLL
            Else
                GetLastError = Apci01GetLastError(wLogSlot)
            End If
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-G01 Error")
            GetLastError = ERR_WRAPDLL
            mErrWradll = SUCCESS            ' NA
        End Try
    End Function
    '============================================================================
    '           GPIBð̎擾
    '           wLogSlot                foCX̘_Xbgԍ
    ' ߂l        Xe[^X
    '============================================================================
    Function GetStatus(ByVal wLogSlot As Short) As Integer
        Try
            GetStatus = Apci01GetStatus(wLogSlot)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-G01 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            GetStatus = 0
        End Try
    End Function
    '============================================================================
    '           DLL,޲ײްްޮݔԍ擾
    '           pdwDllVersion           DLLްޮݔԍi[̈ւ߲
    '               pdwDriverVersion        ޲ײްްޮݔԍi[̈ւ߲
    ' ߂l            True
    '               s    False
    '============================================================================
    Function GetVersion(ByRef pdwDllVersion As Integer, ByRef pdwDriverVersion As Integer) As Boolean
        Try
            GetVersion = Apci01GetVersion(pdwDllVersion, pdwDriverVersion)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-G01 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            GetVersion = False
        End Try
    End Function
    '============================================================================
    '           ޲̎gp錾
    '           pwLogSlot               gpfoCX̘_Xbgԍi[߲
    ' ߂l            True
    '               s    False
    '============================================================================
    Function Create(ByRef pwLogSlot As Short) As Boolean
        Try
            Create = Apci01Create(pwLogSlot)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-G01 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            Create = False
        End Try
    End Function
    '============================================================================
    '           ޲J
    '           wLogSlot                foCX̘_Xbgԍ
    ' ߂l            True
    '               s    False
    '============================================================================
    Function Close(ByVal wLogSlot As Short) As Boolean
        Try
            Close = Apci01Close(wLogSlot)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-G01 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            Close = False
        End Try
    End Function
    '============================================================================
    '           w޲ؿ擾
    '           wLogSlot                foCX̘_Xbgԍ
    '               pResInfo                ؿi[\߲̂
    ' ߂l            True
    '               s    False
    '============================================================================
    Function GetResource(ByVal wLogSlot As Short, ByRef pResInfo As Resource) As Boolean
        Try
            GetResource = Apci01GetResource(wLogSlot, pResInfo)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-G01 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            GetResource = False
        End Try
    End Function
    '============================================================================
    '           
    '           wLogSlot                foCX̘_Xbgԍ
    '               wGpibAddr               g GP-IB AhX
    '               wGpibMode               g GP-IB 샂[h
    '               dwFifoSize              Mobt@̑傫
    ' ߂l            True
    '               s    False
    '============================================================================
    Function Init(ByVal wLogSlot As Short, ByVal wGpibAddr As Short, ByVal wGpibMode As Short, ByVal dwFifoSize As Integer) As Boolean
        Try
            Init = Apci01Init(wLogSlot, wGpibAddr, wGpibMode, dwFifoSize)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-G01 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            Init = False
        End Try
    End Function
    '============================================================================
    '           GPIBѱĐݒ
    '           wLogSlot                foCX̘_Xbgԍ
    '               dwTimeoutCnt            ^CAEglBPʂ̓~b0`60000܂ŁB
    ' ߂l            True
    '               s    False
    '============================================================================
    Function SetTime(ByVal wLogSlot As Short, ByVal dwTimeoutCnt As Integer) As Boolean
        Try
            SetTime = Apci01SetTime(wLogSlot, dwTimeoutCnt)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-G01 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            SetTime = False
        End Try
    End Function
    '============================================================================
    '           EOIݒ
    '           wLogSlot                foCX̘_Xbgԍ
    '               wDlmMode                f~^w
    '               wEoiMode                dnh̎gp܂͕sgpw
    ' ߂l            True
    '               s    False
    '============================================================================
    Function SetEos(ByVal wLogSlot As Short, ByVal wDlmMode As Short, ByVal wEoiMode As Short) As Boolean
        Try
            SetEos = Apci01SetEos(wLogSlot, wDlmMode, wEoiMode)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-G01 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            SetEos = False
        End Try
    End Function
    '============================================================================
    '           GPIBޑM(۰חp)
    '           wLogSlot                foCX̘_Xbgԍ
    '               paSendBuf               MR}hobt@̃AhX
    '               dwSendBytes             MׂR}h̃oCg
    ' ߂l            True
    '               s    False
    '============================================================================
    Function SendCmd(ByVal wLogSlot As Short, ByRef paSendBuf() As Byte, ByVal dwSendBytes As Integer) As Boolean
        Try
            SendCmd = Apci01SendCmd(wLogSlot, paSendBuf(LBound(paSendBuf)), dwSendBytes)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-G01 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            SendCmd = False
        End Try
    End Function
    '============================================================================
    '           IFCM(۰חp)
    '           wLogSlot                foCX̘_Xbgԍ
    ' ߂l            True
    '               s    False
    '============================================================================
    Function Ifc(ByVal wLogSlot As Short) As Boolean
        Try
            Ifc = Apci01Ifc(wLogSlot)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-G01 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            Ifc = False
        End Try
    End Function
    '============================================================================
    '           RENײ݂̐ݒ(۰חp)
    '           wLogSlot                foCX̘_Xbgԍ
    '               wRenLine                1(^)/0(U)
    ' ߂l            True
    '               s    False
    '============================================================================
    Function Ren(ByVal wLogSlot As Short, ByVal wRenLine As Short) As Boolean
        Try
            Ren = Apci01Ren(wLogSlot, wRenLine)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-G01 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            Ren = False
        End Try
    End Function
    '============================================================================
    '           DCLM(۰חp)
    '           wLogSlot                foCX̘_Xbgԍ
    ' ߂l            True
    '               s    False
    '============================================================================
    Function Dcl(ByVal wLogSlot As Short) As Boolean
        Try
            Dcl = Apci01Dcl(wLogSlot)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-G01 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            Dcl = False
        End Try
    End Function
    '============================================================================
    '           w@ւSDCM(۰חp)
    '           wLogSlot                foCX̘_Xbgԍ
    '               wLsnAdrs                XiAhX
    ' ߂l            True
    '               s    False
    '============================================================================
    Function Sdc(ByVal wLogSlot As Short, ByVal wLsnAdrs As Short) As Boolean
        Try
            Sdc = Apci01Sdc(wLogSlot, wLsnAdrs)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-G01 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            Sdc = False
        End Try
    End Function
    '============================================================================
    '           ̎w@ւްM(۰חp)
    '           wLogSlot                foCX̘_Xbgԍ
    '               pwLsnAdrsList           XiAhXXg̃AhX
    '               wLsnAdrsCnt             XiAhX̐
    '               pbSendBuff              Mf[^obt@̃AhX
    '               dwDataCnt               Mf[^
    ' ߂l            True
    '               s False
    '============================================================================
    Function SendDataCN(ByVal wLogSlot As Short, ByRef pwLsnAdrsList() As Short, ByVal wLsnAdrsCnt As Short, ByRef pbSendBuff() As Byte, ByVal dwDataCnt As Integer) As Boolean
        Try
            SendDataCN = Apci01SendDataCN(wLogSlot, pwLsnAdrsList(LBound(pwLsnAdrsList)), wLsnAdrsCnt, pbSendBuff(LBound(pbSendBuff)), dwDataCnt)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-G01 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            SendDataCN = False
        End Try
    End Function
    '============================================================================
    '           w@ւްM(۰חp)
    '           wLogSlot                foCX̘_Xbgԍ
    '               wLsnAdrs                XiAhX
    '               pbSendBuff              Mf[^obt@̃AhX
    '               dwDataCnt               Mf[^
    ' ߂l            True
    '               s    False
    '============================================================================
    Function SendDataC(ByVal wLogSlot As Short, ByVal wLsnAdrs As Short, ByRef pbSendBuff() As Byte, ByVal dwDataCnt As Integer) As Boolean
        Try
            SendDataC = Apci01SendDataC(wLogSlot, wLsnAdrs, pbSendBuff(LBound(pbSendBuff)), dwDataCnt)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-G01 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            SendDataC = False
        End Try
    End Function
    '============================================================================
    '           ްM(ڰޗp)
    '           wLogSlot                foCX̘_Xbgԍ
    '               pbSendBuff              Mf[^obt@̃AhX
    '               dwDataCnt               Mf[^
    ' ߂l            True
    '               s    False
    '============================================================================
    Function SendDataS(ByVal wLogSlot As Short, ByRef pbSendBuff() As Byte, ByVal dwDataCnt As Integer) As Boolean
        Try
            SendDataS = Apci01SendDataS(wLogSlot, pbSendBuff(LBound(pbSendBuff)), dwDataCnt)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-G01 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            SendDataS = False
        End Try
    End Function
    '============================================================================
    '           w@킩ްM(۰חp)
    '           wLogSlot                foCX̘_Xbgԍ
    '               wTlkAdrs                g[JAhX
    '               pbRecvBuff              Mf[^obt@̃AhX
    '               pdwDataCnt              Mf[^w肷ϐ̃AhX
    ' ߂l            True
    '               s    False
    '============================================================================
    Function RecvDataC(ByVal wLogSlot As Short, ByVal wTlkAdrs As Short, ByRef pbRecvBuff() As Byte, ByRef pdwDataCnt As Integer) As Boolean
        Try
            RecvDataC = Apci01RecvDataC(wLogSlot, wTlkAdrs, pbRecvBuff(LBound(pbRecvBuff)), pdwDataCnt)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-G01 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            RecvDataC = False
        End Try
    End Function
    '============================================================================
    '           ްM(ڰޗp)
    '           wLogSlot                foCX̘_Xbgԍ
    '               pbRecvBuff              Mf[^obt@̃AhX
    '               pdwDataCnt              Mf[^w肷ϐ̃AhX
    ' ߂l            True
    '               s    False
    '============================================================================
    Function RecvDataS(ByVal wLogSlot As Short, ByRef pbRecvBuff() As Byte, ByRef pdwDataCnt As Integer) As Boolean
        Try
            RecvDataS = Apci01RecvDataS(wLogSlot, pbRecvBuff(LBound(pbRecvBuff)), pdwDataCnt)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-G01 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            RecvDataS = False
        End Try
    End Function
    '============================================================================
    '           @ް](۰חp)
    '           wLogSlot                foCX̘_Xbgԍ
    '               wTlkAdrs                g[JAhX
    '               pwLsnAdrsList           XiAhXXg̃AhX
    '               wLsnAdrsCnt             XiAhX̐
    ' ߂l            True
    '               s    False
    '============================================================================
    Function TransDataN(ByVal wLogSlot As Short, ByVal wTlkAdrs As Short, ByRef pwLsnAdrsList() As Short, ByVal wLsnAdrsCnt As Short) As Boolean
        Try
            TransDataN = Apci01TransDataN(wLogSlot, wTlkAdrs, pwLsnAdrsList(LBound(pwLsnAdrsList)), wLsnAdrsCnt)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-G01 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            TransDataN = False
        End Try
    End Function
    '============================================================================
    '           @ް](۰חp)
    '           wLogSlot                foCX̘_Xbgԍ
    '               wTlkAdrs                g[JAhX
    '               wLsnAdrs                XiAhX
    ' ߂l            True
    '               s    False
    '============================================================================
    Function TransData(ByVal wLogSlot As Short, ByVal wTlkAdrs As Short, ByVal wLsnAdrs As Short) As Boolean
        Try
            TransData = Apci01TransData(wLogSlot, wTlkAdrs, wLsnAdrs)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-G01 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            TransData = False
        End Try
    End Function
    '============================================================================
    '           SRQײ݂ƽð޲Đݒ(ڰޗp)
    '           wLogSlot                foCX̘_Xbgԍ
    '               bStsByte                Xe[^XoCgl
    ' ߂l            True
    '               s    False
    '============================================================================
    Function SetSrqLine(ByVal wLogSlot As Short, ByVal bStsByte As Byte) As Boolean
        Try
            SetSrqLine = Apci01SetSrqLine(wLogSlot, bStsByte)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-G01 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            SetSrqLine = False
        End Try
    End Function
    '============================================================================
    '           SRQײ݂̏Ԕ(۰חp)
    '           wLogSlot                foCX̘_Xbgԍ
    '               pwSrqLine               rqpCԂi[ϐ̃AhX
    ' ߂l            True
    '               s    False
    '============================================================================
    Function GetSrqLine(ByVal wLogSlot As Short, ByRef pwSrqLine As Short) As Boolean
        Try
            GetSrqLine = Apci01GetSrqLine(wLogSlot, pwSrqLine)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-G01 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            GetSrqLine = False
        End Try
    End Function
    '============================================================================
    '           رَ߰s(۰חp)
    '           wLogSlot                foCX̘_Xbgԍ
    '               wPollAdrs               |[ÕAhX
    '               pbStsByte               Xe[^XoCgi[ϐ̃AhX
    ' ߂l            True
    '               s    False
    '============================================================================
    Function Spoll(ByVal wLogSlot As Short, ByVal wPollAdrs As Short, ByRef pbStsByte As Byte) As Boolean
        Try
            Spoll = Apci01Spoll(wLogSlot, wPollAdrs, pbStsByte)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-G01 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            Spoll = False
        End Try
    End Function
    '============================================================================
    '           َ߰s(۰חp)
    '           wLogSlot                foCX̘_Xbgԍ
    '               pbDioLine               chnCi[ϐ̃AhX
    ' ߂l            True
    '               s    False
    '============================================================================
    Function Ppoll(ByVal wLogSlot As Short, ByRef pbDioLine As Byte) As Boolean
        Try
            Ppoll = Apci01Ppoll(wLogSlot, pbDioLine)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-G01 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            Ppoll = False
        End Try
    End Function
    '============================================================================
    '           ٍ߰\(۰חp)
    '           wLogSlot                foCX̘_Xbgԍ
    '               wLsnAdrs                \@AhX
    '               bDioLine                @tDIOCԍiO`ṼrbgԍŎwj
    '               bSbit                   ZXrbg̎wiO܂͂Pj
    ' ߂l            True
    '               s    False
    '============================================================================
    Function PpollConfig(ByVal wLogSlot As Short, ByVal wLsnAdrs As Short, ByVal bDioLine As Byte, ByVal bSbit As Byte) As Boolean
        Try
            PpollConfig = Apci01PpollConfig(wLogSlot, wLsnAdrs, bDioLine, bSbit)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-G01 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            PpollConfig = False
        End Try
    End Function
    '============================================================================
    '           w@ٍ߰\(۰חp)
    '           wLogSlot                foCX̘_Xbgԍ
    '               wLsnAdrs                \@AhX
    ' ߂l            True
    '               s    False
    '============================================================================
    Function PpollUnConfig(ByVal wLogSlot As Short, ByVal wLsnAdrs As Short) As Boolean
        Try
            PpollUnConfig = Apci01PpollUnConfig(wLogSlot, wLsnAdrs)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-G01 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            PpollUnConfig = False
        End Try
    End Function
    '============================================================================
    '           S@ٍ߰\(۰חp)
    '           wLogSlot                foCX̘_Xbgԍ
    ' ߂l            True
    '               s    False
    '============================================================================
    Function PpollUnConfigAll(ByVal wLogSlot As Short) As Boolean
        Try
            PpollUnConfigAll = Apci01PpollUnConfigAll(wLogSlot)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-G01 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            PpollUnConfigAll = False
        End Try
    End Function
    '============================================================================
    '           ߰ىݒ(ڰޗp)
    '           wLogSlot                foCX̘_Xbgԍ
    '               wPMode                  p|[ւ̉@
    ' ߂l            True
    '               s    False
    '============================================================================
    Function PpollRespModeSet(ByVal wLogSlot As Short, ByVal wPMode As Short) As Boolean
        Try
            PpollRespModeSet = Apci01PpollRespModeSet(wLogSlot, wPMode)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-G01 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            PpollRespModeSet = False
        End Try
    End Function
    '============================================================================
    '           BSNXCb`l擾
    '           wLogSlot                foCX̘_Xbgԍ
    '               wPMode                  armXCb`i[̈
    ' ߂l            True
    '               s    False
    '============================================================================
    Function GetSwitchValue(ByVal wLogSlot As Short, ByRef pdwSwitchValue As Integer) As Boolean
        Try
            GetSwitchValue = Apci01GetSwitchValue(wLogSlot, pdwSwitchValue)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-G01 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            GetSwitchValue = False
        End Try
    End Function
    '============================================================================
    '           DIP-SW ̒l擾܂
    '           wLogSlot                foCX̘_Xbgԍ
    '               pbDipsw                  DIP-SW ̒li[̈
    ' ߂l            True
    '               s    False
    '============================================================================
    Function GetDipSwitch(ByVal wLogSlot As Short, ByRef pbDipsw As Byte) As Boolean
        Try
            GetDipSwitch = Apci01GetDipSwitch(wLogSlot, pbDipsw)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "aPCI-G01 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            GetDipSwitch = False
        End Try
    End Function

End Class
