Attribute VB_Name = "DLLDef"
'===================================================================
' Apci01.bas
'-------------------------------------------------------------------
' aPCI-G01
' Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
'===================================================================
Option Explicit
'-------------------------------------------------------------------
' G[R[h
'-------------------------------------------------------------------
Global Const APCI01_SUCCESS = 0               ' ُȂiIj
Global Const APCI01_ERR_SYSTEM = 1            ' ɃhCo[hĂȂ\܂
Global Const APCI01_ERR_NO_DEVICE = 2         ' gp\ȃfoCX܂
Global Const APCI01_ERR_IN_USE = 3            ' w̃foCX͑̃vZXŎgpł
Global Const APCI01_ERR_INVALID_SLOT = 4      ' Ș_Xbgԍł
Global Const APCI01_ERR_RESOURCE = 5          ' \[XG[
Global Const APCI01_ERR_INVALID_ARGUMENT = 6  ' sȈw肵܂
Global Const APCI01_ERR_NOTINIT = 7           ' Ă܂B
Global Const APCI01_ERR_MODE = 8              ' GPIB ̃[hG[łB
Global Const APCI01_ERR_TIMEOUT = 9           ' ^CAEg܂B
Global Const APCI01_ERR_NOLSN = 10            ' XiiP[uڑj
Global Const APCI01_ERR_BUSY = 11             ' s
Global Const APCI01_ERR_ETC = 12              ' ̑̃G[

'-------------------------------------------------------------------
' GPIBXe[^X擾
'-------------------------------------------------------------------
Global Const STS_IFC = &H1                    ' IFC
Global Const STS_DCAS = &H2                   ' DeviceClear
Global Const STS_UNC = &H4                    ' Ppoll,TCT etc
Global Const STS_ERR = &H8                    ' Error
Global Const STS_GET = &H10                   ' GET
Global Const STS_SPAS = &H20                  ' Spoll
Global Const STS_END = &H40                   ' END
Global Const STS_REM = &H100                  ' Remote
Global Const STS_LLO = &H200                  ' LLO
Global Const STS_TLK = &H400                  ' Talker
Global Const STS_LSN = &H800                  ' Listener
Global Const STS_ATN = &H1000                 ' ATN
Global Const STS_SRQ = &H2000                 ' SRQ
Global Const STS_REN = &H4000                 ' REN
'-------------------------------------------------------------------
' GPIB֘Ap[^w͈
'-------------------------------------------------------------------
Global Const ADDR_MIN = 0                     ' ŏGPIBڽ
Global Const ADDR_MAX = 30                    ' ő    "
Global Const TIMEOUT_DEFAULT = 2000           ' ѱ̫
Global Const TIMEOUT_MAX = 60000              ' ѱčől
'-------------------------------------------------------------------
' }`CbZ[W(GPIBR}h)w
'-------------------------------------------------------------------
Global Const LA_0 = &H20                      ' Listener Addr
Global Const TA_0 = &H40                      ' Talker Addr
Global Const UNL = &H3F                       ' UNListen
Global Const UNT = &H5F                       ' UNTalk
Global Const GTL = &H1                        ' Go To Local
Global Const SDC = &H4                        ' Select Device Clear
Global Const GETRG = &H8                      ' Group Execute Trigger
Global Const LLO = &H11                       ' Local Lock Out
Global Const DCL = &H14                       ' Device Clear
Global Const SPE = &H18                       ' Serial Poll Enable
Global Const SPD = &H19                       ' Serial Poll Disable
Global Const PPC = &H5                        ' Parallel Poll Config
Global Const PPE = &H60                       ' Parallel Poll Enable
Global Const PPZ = &H70                       ' Parallel Poll Disable
Global Const PPU = &H15                       ' Parallel Poll Unconfig
Global Const TCT = &H9                        ' Take Control (XXX)
'-------------------------------------------------------------------
' GPIB샂[hw
'-------------------------------------------------------------------
Global Const MODE_SYSCON = 1                  ' Ѻ۰Ӱ
Global Const MODE_TLKLSN = 0                  ' İؽӰ
Global Const MODE_SLAVE = 0                   ' ڰӰ
Global Const MODE_CON = 2                     ' ۰Ӱ(gps)
Global Const MODE_MASTER = 2                  ' ϽӰ(gps)
'-------------------------------------------------------------------
' f~^[hw
'-------------------------------------------------------------------
Global Const DELIM_CRLF = 1                   ' CR + LF(̫)
Global Const DELIM_CR = 2                     ' CR
Global Const DELIM_LF = 3                     ' LF
Global Const DELIM_NO = 0                     ' NOTHING
'-------------------------------------------------------------------
' dnh[hw
'-------------------------------------------------------------------
Global Const EOI_ON = 1                       ' t(̫)
Global Const EOI_OFF = 0                      ' Ȃ
'-------------------------------------------------------------------
' ̑̒萔
'-------------------------------------------------------------------
Global Const APCI01_SLOT_AUTO = &HFFFF
Global Const APCI01_MAX_SLOTS = 16            ' foCX͂PU܂Ŏg܂
'-------------------------------------------------------------------
' \[X\̊evf̍ő吔
'-------------------------------------------------------------------
Global Const APCI01_MAX_MEM = 9
Global Const APCI01_MAX_IO = 20
Global Const APCI01_MAX_IRQ = 7
Global Const APCI01_MAX_DMA = 7
'-------------------------------------------------------------------
' \[X\
'-------------------------------------------------------------------
Type APCI01_RESOURCE
    dwNumMemWindows As Long                       ' EBhE
    dwMemBase(1 To APCI01_MAX_MEM) As Long        ' EBhEJnAhX
    dwMemLength(1 To APCI01_MAX_MEM) As Long      ' EBhE
    dwMemAttrib(1 To APCI01_MAX_MEM) As Long      ' EBhE
    dwNumIOPorts As Long                          ' I/O|[g
    dwIOPortBase(1 To APCI01_MAX_IO) As Long      ' I/O|[gJnAhX
    dwIOPortLength(1 To APCI01_MAX_IO) As Long    ' I/O|[g
    dwNumIRQs As Long                             ' IRQ
    dwIRQRegisters(1 To APCI01_MAX_IRQ) As Long   ' IRQԍ
    dwIRQAttrib(1 To APCI01_MAX_IRQ) As Long      ' IRQ
    dwNumDMAs As Long                             ' DMA`l
    dwDMALst(1 To APCI01_MAX_DMA) As Long         ' DMA`l
    dwDMAAttrib(1 To APCI01_MAX_DMA) As Long      ' DMA`l
    dwReserved1(1 To 3) As Long                   ' \
End Type
'-------------------------------------------------------------------
' API Functions
'-------------------------------------------------------------------
Public Declare Function Apci01GetLastError Lib "Apci01" (ByVal wLogSlot As Integer) As Long
Public Declare Function Apci01GetStatus Lib "Apci01" (ByVal wLogSlot As Integer) As Long
Public Declare Function Apci01GetVersion Lib "Apci01" (ByRef pdwDllVersion As Long, ByRef pdwDriverVersion As Long) As Boolean
Public Declare Function Apci01Create Lib "Apci01" (ByRef pwLogSlot As Integer) As Boolean
Public Declare Function Apci01Close Lib "Apci01" (ByVal wLogSlot As Integer) As Boolean
Public Declare Function Apci01GetResource Lib "Apci01" (ByVal wLogSlot As Integer, ByRef pResInfo As APCI01_RESOURCE) As Boolean
Public Declare Function Apci01Init Lib "Apci01" (ByVal wLogSlot As Integer, ByVal wGpibAddr As Integer, ByVal wGpibMode As Integer, ByVal dwFifoSize As Long) As Boolean
Public Declare Function Apci01SetTime Lib "Apci01" (ByVal wLogSlot As Integer, ByVal dwTimeoutCnt As Long) As Boolean
Public Declare Function Apci01SetEos Lib "Apci01" (ByVal wLogSlot As Integer, ByVal wDlmMode As Integer, ByVal wEoiMode As Integer) As Boolean
Public Declare Function Apci01SendCmd Lib "Apci01" (ByVal wLogSlot As Integer, ByRef paSendBuf As Byte, ByVal dwSendBytes As Long) As Boolean
Public Declare Function Apci01Ifc Lib "Apci01" (ByVal wLogSlot As Integer) As Boolean
Public Declare Function Apci01Ren Lib "Apci01" (ByVal wLogSlot As Integer, ByVal wRenLine As Integer) As Boolean
Public Declare Function Apci01Dcl Lib "Apci01" (ByVal wLogSlot As Integer) As Boolean
Public Declare Function Apci01Sdc Lib "Apci01" (ByVal wLogSlot As Integer, ByVal wLsnAdrs As Integer) As Boolean
Public Declare Function Apci01SendDataCN Lib "Apci01" (ByVal wLogSlot As Integer, ByRef pwLsnAdrsList As Integer, ByVal wLsnAdrsCnt As Integer, ByRef pbSendBuff As Byte, ByVal dwDataCnt As Long) As Boolean
Public Declare Function Apci01SendDataC Lib "Apci01" (ByVal wLogSlot As Integer, ByVal wLsnAdrs As Integer, ByRef pbSendBuff As Byte, ByVal dwDataCnt As Long) As Boolean
Public Declare Function Apci01SendDataS Lib "Apci01" (ByVal wLogSlot As Integer, ByRef pbSendBuff As Byte, ByVal dwDataCnt As Long) As Boolean
Public Declare Function Apci01RecvDataC Lib "Apci01" (ByVal wLogSlot As Integer, ByVal wTlkAdrs As Integer, ByRef pbRecvBuff As Byte, ByRef pdwDataCnt As Long) As Boolean
Public Declare Function Apci01RecvDataS Lib "Apci01" (ByVal wLogSlot As Integer, ByRef pbRecvBuff As Byte, ByRef pdwDataCnt As Long) As Boolean
Public Declare Function Apci01TransDataN Lib "Apci01" (ByVal wLogSlot As Integer, ByVal wTlkAdrs As Integer, ByRef pwLsnAdrsList As Integer, ByVal wLsnAdrsCnt As Integer) As Boolean
Public Declare Function Apci01TransData Lib "Apci01" (ByVal wLogSlot As Integer, ByVal wTlkAdrs As Integer, ByVal wLsnAdrs As Integer) As Boolean
Public Declare Function Apci01SetSrqLine Lib "Apci01" (ByVal wLogSlot As Integer, ByVal bStsByte As Byte) As Boolean
Public Declare Function Apci01GetSrqLine Lib "Apci01" (ByVal wLogSlot As Integer, ByRef pwSrqLine As Integer) As Boolean
Public Declare Function Apci01Spoll Lib "Apci01" (ByVal wLogSlot As Integer, ByVal wPollAdrs As Integer, ByRef pbStsByte As Byte) As Boolean
Public Declare Function Apci01Ppoll Lib "Apci01" (ByVal wLogSlot As Integer, ByRef pbDioLine As Byte) As Boolean
Public Declare Function Apci01PpollConfig Lib "Apci01" (ByVal wLogSlot As Integer, ByVal wLsnAdrs As Integer, ByVal bDioLine As Byte, ByVal bSbit As Byte) As Boolean
Public Declare Function Apci01PpollUnConfig Lib "Apci01" (ByVal wLogSlot As Integer, ByVal wLsnAdrs As Integer) As Boolean
Public Declare Function Apci01PpollUnConfigAll Lib "Apci01" (ByVal wLogSlot As Integer) As Boolean
Public Declare Function Apci01PpollRespModeSet Lib "Apci01" (ByVal wLogSlot As Integer, ByVal wPMode As Integer) As Boolean
Public Declare Function Apci01GetSwitchValue Lib "Apci01" (ByVal wLogSlot As Integer, ByRef pdwSwitchValue As Long) As Boolean
Public Declare Function Apci01GetDipSwitch Lib "Apci01" (ByVal wLogSlot As Integer, ByRef pbDipsw As Byte) As Boolean




