Attribute VB_Name = "Wrapper"
'============================================================================
' Apci01w.bas
'----------------------------------------------------------------------------
' aPCI-G01
' Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
'============================================================================
Option Explicit
Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" (ByVal lpLibFileName As String) As Long
Declare Function FreeLibrary Lib "kernel32" (ByVal hLibModule As Long) As Long
Declare Function GetProcAddress Lib "kernel32" (ByVal hModule As Long, ByVal lpProcName As String) As Long

Global Const APCI01_DLL_NAME = "Apci01.dll"   ' DLL
Dim hDLL As Long                              ' DLLւ̃nh
Global Const APCI01_ERR_WRAPDLL = -1          ' bp[֐G[

'============================================================================
'           DLL۰(۰ގʹװƂ)
'           
' ߂l            True
'               s    False
'============================================================================
Function Apci01wDllOpen() As Boolean
    Apci01wDllOpen = True
    If hDLL = 0 Then
        hDLL = LoadLibrary(APCI01_DLL_NAME)
        If hDLL <> 0 Then
            If Apci01wGetDllExportFunc() = True Then
                Exit Function
            Else
                ' DLL GNX|[g֐LmFɎŝŁADLL N[Y
                Apci01wDllClose
            End If
        End If
    End If
    Apci01wDllOpen = False
End Function
'============================================================================
'           DLL۰(۰ގʹװƂ)
'           
' ߂l            True
'               s    False
'============================================================================
Function Apci01wDllClose() As Boolean
    Apci01wDllClose = True
    If hDLL = 0 Then
        If FreeLibrary(hDLL) <> 0 Then
            hDLL = 0
            Exit Function
        End If
    End If
    Apci01wDllClose = False
End Function
'============================================================================
'           װނ̎擾
'           wLogSlot                foCX̘_Xbgԍ
' ߂l        װ
'============================================================================
Function Apci01wGetLastError(ByVal wLogSlot As Integer) As Long
    Apci01wGetLastError = APCI01_ERR_WRAPDLL
        If hDLL = 0 Then
            Exit Function
        Else
            Apci01wGetLastError = Apci01GetLastError(wLogSlot)
        End If
End Function
'============================================================================
'           GPIBð̎擾
'           wLogSlot                foCX̘_Xbgԍ
' ߂l        Xe[^X
'============================================================================
Function Apci01wGetStatus(ByVal wLogSlot As Integer) As Long
    If hDLL = 0 Then Exit Function
    Apci01wGetStatus = Apci01GetStatus(wLogSlot)
End Function
'============================================================================
'           DLL,޲ײްްޮݔԍ擾
'           pdwDllVersion           DLLްޮݔԍi[̈ւ߲
'               pdwDriverVersion        ޲ײްްޮݔԍi[̈ւ߲
' ߂l            True
'               s    False
'============================================================================
Function Apci01wGetVersion(ByRef pdwDllVersion As Long, ByRef pdwDriverVersion As Long) As Boolean
    Apci01wGetVersion = False
    If hDLL = 0 Then Exit Function
    If Apci01GetVersion(pdwDllVersion, pdwDriverVersion) = 0 Then Exit Function
    Apci01wGetVersion = True
End Function
'============================================================================
'           ޲̎gp錾
'           pwLogSlot               gpfoCX̘_Xbgԍi[߲
' ߂l            True
'               s    False
'============================================================================
Function Apci01wCreate(ByRef pwLogSlot As Integer) As Boolean
    Apci01wCreate = False
    If hDLL = 0 Then Exit Function
    If Apci01Create(pwLogSlot) = 0 Then Exit Function
    Apci01wCreate = True
End Function
'============================================================================
'           ޲J
'           wLogSlot                foCX̘_Xbgԍ
' ߂l            True
'               s    False
'============================================================================
Function Apci01wClose(ByVal wLogSlot As Integer) As Boolean
    Apci01wClose = False
    If hDLL = 0 Then Exit Function
    If Apci01Close(wLogSlot) = 0 Then Exit Function
    Apci01wClose = True
End Function
'============================================================================
'           w޲ؿ擾
'           wLogSlot                foCX̘_Xbgԍ
'               pResInfo                ؿi[\߲̂
' ߂l            True
'               s    False
'============================================================================
Function Apci01wGetResource(ByVal wLogSlot As Integer, ByRef pResInfo As APCI01_RESOURCE) As Boolean
    Apci01wGetResource = False
    If hDLL = 0 Then Exit Function
    If Apci01GetResource(wLogSlot, pResInfo) = 0 Then Exit Function
    Apci01wGetResource = True
End Function
'============================================================================
'           
'           wLogSlot                foCX̘_Xbgԍ
'               wGpibAddr               g GP-IB AhX
'               wGpibMode               g GP-IB 샂[h
'               dwFifoSize              Mobt@̑傫
' ߂l            True
'               s    False
'============================================================================
Function Apci01wInit(ByVal wLogSlot As Integer, ByVal wGpibAddr As Integer, ByVal wGpibMode As Integer, ByVal dwFifoSize As Long) As Boolean
    Apci01wInit = False
    If hDLL = 0 Then Exit Function
    If Apci01Init(wLogSlot, wGpibAddr, wGpibMode, dwFifoSize) = 0 Then Exit Function
    Apci01wInit = True
End Function
'============================================================================
'           GPIBѱĐݒ
'           wLogSlot                foCX̘_Xbgԍ
'               dwTimeoutCnt            ^CAEglBPʂ̓~b0`60000܂ŁB
' ߂l            True
'               s    False
'============================================================================
Function Apci01wSetTime(ByVal wLogSlot As Integer, ByVal dwTimeoutCnt As Long) As Boolean
    Apci01wSetTime = False
    If hDLL = 0 Then Exit Function
    If Apci01SetTime(wLogSlot, dwTimeoutCnt) = 0 Then Exit Function
    Apci01wSetTime = True
End Function
'============================================================================
'           EOIݒ
'           wLogSlot                foCX̘_Xbgԍ
'               wDlmMode                f~^w
'               wEoiMode                dnh̎gp܂͕sgpw
' ߂l            True
'               s    False
'============================================================================
Function Apci01wSetEos(ByVal wLogSlot As Integer, ByVal wDlmMode As Integer, ByVal wEoiMode As Integer) As Boolean
    Apci01wSetEos = False
    If hDLL = 0 Then Exit Function
    If Apci01SetEos(wLogSlot, wDlmMode, wEoiMode) = 0 Then Exit Function
    Apci01wSetEos = True
End Function
'============================================================================
'           GPIBޑM(۰חp)
'           wLogSlot                foCX̘_Xbgԍ
'               paSendBuf               MR}hobt@̃AhX
'               dwSendBytes             MׂR}h̃oCg
' ߂l            True
'               s    False
'============================================================================
Function Apci01wSendCmd(ByVal wLogSlot As Integer, ByRef paSendBuf() As Byte, ByVal dwSendBytes As Long) As Boolean
    Apci01wSendCmd = False
    If hDLL = 0 Then Exit Function
    If Apci01SendCmd(wLogSlot, paSendBuf(LBound(paSendBuf)), dwSendBytes) = 0 Then Exit Function
    Apci01wSendCmd = True
End Function
'============================================================================
'           IFCM(۰חp)
'           wLogSlot                foCX̘_Xbgԍ
' ߂l            True
'               s    False
'============================================================================
Function Apci01wIfc(ByVal wLogSlot As Integer) As Boolean
    Apci01wIfc = False
    If hDLL = 0 Then Exit Function
    If Apci01Ifc(wLogSlot) = 0 Then Exit Function
    Apci01wIfc = True
End Function
'============================================================================
'           RENײ݂̐ݒ(۰חp)
'           wLogSlot                foCX̘_Xbgԍ
'               wRenLine                1(^)/0(U)
' ߂l            True
'               s    False
'============================================================================
Function Apci01wRen(ByVal wLogSlot As Integer, ByVal wRenLine As Integer) As Boolean
    Apci01wRen = False
    If hDLL = 0 Then Exit Function
    If Apci01Ren(wLogSlot, wRenLine) = 0 Then Exit Function
    Apci01wRen = True
End Function
'============================================================================
'           DCLM(۰חp)
'           wLogSlot                foCX̘_Xbgԍ
' ߂l            True
'               s    False
'============================================================================
Function Apci01wDcl(ByVal wLogSlot As Integer) As Boolean
    Apci01wDcl = False
    If hDLL = 0 Then Exit Function
    If Apci01Dcl(wLogSlot) = 0 Then Exit Function
    Apci01wDcl = True
End Function
'============================================================================
'           w@ւSDCM(۰חp)
'           wLogSlot                foCX̘_Xbgԍ
'               wLsnAdrs                XiAhX
' ߂l            True
'               s    False
'============================================================================
Function Apci01wSdc(ByVal wLogSlot As Integer, ByVal wLsnAdrs As Integer) As Boolean
    Apci01wSdc = False
    If hDLL = 0 Then Exit Function
    If Apci01Sdc(wLogSlot, wLsnAdrs) = 0 Then Exit Function
    Apci01wSdc = True
End Function
'============================================================================
'           ̎w@ւްM(۰חp)
'           wLogSlot                foCX̘_Xbgԍ
'               pwLsnAdrsList           XiAhXXg̃AhX
'               wLsnAdrsCnt             XiAhX̐
'               pbSendBuff              Mf[^obt@̃AhX
'               dwDataCnt               Mf[^
' ߂l            True
'               s False
'============================================================================
Function Apci01wSendDataCN(ByVal wLogSlot As Integer, ByRef pwLsnAdrsList() As Integer, ByVal wLsnAdrsCnt As Integer, ByRef pbSendBuff() As Byte, ByVal dwDataCnt As Long) As Boolean
    Apci01wSendDataCN = False
    If hDLL = 0 Then Exit Function
    If Apci01SendDataCN(wLogSlot, pwLsnAdrsList(LBound(pwLsnAdrsList)), wLsnAdrsCnt, pbSendBuff(LBound(pbSendBuff)), dwDataCnt) = 0 Then Exit Function
    Apci01wSendDataCN = True
End Function
'============================================================================
'           w@ւްM(۰חp)
'           wLogSlot                foCX̘_Xbgԍ
'               wLsnAdrs                XiAhX
'               pbSendBuff              Mf[^obt@̃AhX
'               dwDataCnt               Mf[^
' ߂l            True
'               s    False
'============================================================================
Function Apci01wSendDataC(ByVal wLogSlot As Integer, ByVal wLsnAdrs As Integer, ByRef pbSendBuff() As Byte, ByVal dwDataCnt As Long) As Boolean
    Apci01wSendDataC = False
    If hDLL = 0 Then Exit Function
    If Apci01SendDataC(wLogSlot, wLsnAdrs, pbSendBuff(LBound(pbSendBuff)), dwDataCnt) = 0 Then Exit Function
    Apci01wSendDataC = True
End Function
'============================================================================
'           ްM(ڰޗp)
'           wLogSlot                foCX̘_Xbgԍ
'               pbSendBuff              Mf[^obt@̃AhX
'               dwDataCnt               Mf[^
' ߂l            True
'               s    False
'============================================================================
Function Apci01wSendDataS(ByVal wLogSlot As Integer, ByRef pbSendBuff() As Byte, ByVal dwDataCnt As Long) As Boolean
    Apci01wSendDataS = False
    If hDLL = 0 Then Exit Function
    If Apci01SendDataS(wLogSlot, pbSendBuff(LBound(pbSendBuff)), dwDataCnt) = 0 Then Exit Function
    Apci01wSendDataS = True
End Function
'============================================================================
'           w@킩ްM(۰חp)
'           wLogSlot                foCX̘_Xbgԍ
'               wTlkAdrs                g[JAhX
'               pbRecvBuff              Mf[^obt@̃AhX
'               pdwDataCnt              Mf[^w肷ϐ̃AhX
' ߂l            True
'               s    False
'============================================================================
Function Apci01wRecvDataC(ByVal wLogSlot As Integer, ByVal wTlkAdrs As Integer, ByRef pbRecvBuff() As Byte, ByRef pdwDataCnt As Long) As Boolean
    Apci01wRecvDataC = False
    If hDLL = 0 Then Exit Function
    If Apci01RecvDataC(wLogSlot, wTlkAdrs, pbRecvBuff(LBound(pbRecvBuff)), pdwDataCnt) = 0 Then Exit Function
    Apci01wRecvDataC = True
End Function
'============================================================================
'           ްM(ڰޗp)
'           wLogSlot                foCX̘_Xbgԍ
'               pbRecvBuff              Mf[^obt@̃AhX
'               pdwDataCnt              Mf[^w肷ϐ̃AhX
' ߂l            True
'               s    False
'============================================================================
Function Apci01wRecvDataS(ByVal wLogSlot As Integer, ByRef pbRecvBuff() As Byte, ByRef pdwDataCnt As Long) As Boolean
    Apci01wRecvDataS = False
    If hDLL = 0 Then Exit Function
    If Apci01RecvDataS(wLogSlot, pbRecvBuff(LBound(pbRecvBuff)), pdwDataCnt) = 0 Then Exit Function
    Apci01wRecvDataS = True
End Function
'============================================================================
'           @ް](۰חp)
'           wLogSlot                foCX̘_Xbgԍ
'               wTlkAdrs                g[JAhX
'               pwLsnAdrsList           XiAhXXg̃AhX
'               wLsnAdrsCnt             XiAhX̐
' ߂l            True
'               s    False
'============================================================================
Function Apci01wTransDataN(ByVal wLogSlot As Integer, ByVal wTlkAdrs As Integer, ByRef pwLsnAdrsList() As Integer, ByVal wLsnAdrsCnt As Integer) As Boolean
    Apci01wTransDataN = False
    If hDLL = 0 Then Exit Function
    If Apci01TransDataN(wLogSlot, wTlkAdrs, pwLsnAdrsList(LBound(pwLsnAdrsList)), wLsnAdrsCnt) = 0 Then Exit Function
    Apci01wTransDataN = True
End Function
'============================================================================
'           @ް](۰חp)
'           wLogSlot                foCX̘_Xbgԍ
'               wTlkAdrs                g[JAhX
'               wLsnAdrs                XiAhX
' ߂l            True
'               s    False
'============================================================================
Function Apci01wTransData(ByVal wLogSlot As Integer, ByVal wTlkAdrs As Integer, ByVal wLsnAdrs As Integer) As Boolean
    Apci01wTransData = False
    If hDLL = 0 Then Exit Function
    If Apci01TransData(wLogSlot, wTlkAdrs, wLsnAdrs) = 0 Then Exit Function
    Apci01wTransData = True
End Function
'============================================================================
'           SRQײ݂ƽð޲Đݒ(ڰޗp)
'           wLogSlot                foCX̘_Xbgԍ
'               bStsByte                Xe[^XoCgl
' ߂l            True
'               s    False
'============================================================================
Function Apci01wSetSrqLine(ByVal wLogSlot As Integer, ByVal bStsByte As Byte) As Boolean
    Apci01wSetSrqLine = False
    If hDLL = 0 Then Exit Function
    If Apci01SetSrqLine(wLogSlot, bStsByte) = 0 Then Exit Function
    Apci01wSetSrqLine = True
End Function
'============================================================================
'           SRQײ݂̏Ԕ(۰חp)
'           wLogSlot                foCX̘_Xbgԍ
'               pwSrqLine               rqpCԂi[ϐ̃AhX
' ߂l            True
'               s    False
'============================================================================
Function Apci01wGetSrqLine(ByVal wLogSlot As Integer, ByRef pwSrqLine As Integer) As Boolean
    Apci01wGetSrqLine = False
    If hDLL = 0 Then Exit Function
    If Apci01GetSrqLine(wLogSlot, pwSrqLine) = 0 Then Exit Function
    Apci01wGetSrqLine = True
End Function
'============================================================================
'           رَ߰s(۰חp)
'           wLogSlot                foCX̘_Xbgԍ
'               wPollAdrs               |[ÕAhX
'               pbStsByte               Xe[^XoCgi[ϐ̃AhX
' ߂l            True
'               s    False
'============================================================================
Function Apci01wSpoll(ByVal wLogSlot As Integer, ByVal wPollAdrs As Integer, ByRef pbStsByte As Byte) As Boolean
    Apci01wSpoll = False
    If hDLL = 0 Then Exit Function
    If Apci01Spoll(wLogSlot, wPollAdrs, pbStsByte) = 0 Then Exit Function
    Apci01wSpoll = True
End Function
'============================================================================
'           َ߰s(۰חp)
'           wLogSlot                foCX̘_Xbgԍ
'               pbDioLine               chnCi[ϐ̃AhX
' ߂l            True
'               s    False
'============================================================================
Function Apci01wPpoll(ByVal wLogSlot As Integer, ByRef pbDioLine As Byte) As Boolean
    Apci01wPpoll = False
    If hDLL = 0 Then Exit Function
    If Apci01Ppoll(wLogSlot, pbDioLine) = 0 Then Exit Function
    Apci01wPpoll = True
End Function
'============================================================================
'           ٍ߰\(۰חp)
'           wLogSlot                foCX̘_Xbgԍ
'               wLsnAdrs                \@AhX
'               bDioLine                @tDIOCԍiO`ṼrbgԍŎwj
'               bSbit                   ZXrbg̎wiO܂͂Pj
' ߂l            True
'               s    False
'============================================================================
Function Apci01wPpollConfig(ByVal wLogSlot As Integer, ByVal wLsnAdrs As Integer, ByVal bDioLine As Byte, ByVal bSbit As Byte) As Boolean
    Apci01wPpollConfig = False
    If hDLL = 0 Then Exit Function
    If Apci01PpollConfig(wLogSlot, wLsnAdrs, bDioLine, bSbit) = 0 Then Exit Function
    Apci01wPpollConfig = True
End Function
'============================================================================
'           w@ٍ߰\(۰חp)
'           wLogSlot                foCX̘_Xbgԍ
'               wLsnAdrs                \@AhX
' ߂l            True
'               s    False
'============================================================================
Function Apci01wPpollUnConfig(ByVal wLogSlot As Integer, ByVal wLsnAdrs As Integer) As Boolean
    Apci01wPpollUnConfig = False
    If hDLL = 0 Then Exit Function
    If Apci01PpollUnConfig(wLogSlot, wLsnAdrs) = 0 Then Exit Function
    Apci01wPpollUnConfig = True
End Function
'============================================================================
'           S@ٍ߰\(۰חp)
'           wLogSlot                foCX̘_Xbgԍ
' ߂l            True
'               s    False
'============================================================================
Function Apci01wPpollUnConfigAll(ByVal wLogSlot As Integer) As Boolean
    Apci01wPpollUnConfigAll = False
    If hDLL = 0 Then Exit Function
    If Apci01PpollUnConfigAll(wLogSlot) = 0 Then Exit Function
    Apci01wPpollUnConfigAll = True
End Function
'============================================================================
'           ߰ىݒ(ڰޗp)
'           wLogSlot                foCX̘_Xbgԍ
'               wPMode                  p|[ւ̉@
' ߂l            True
'               s    False
'============================================================================
Function Apci01wPpollRespModeSet(ByVal wLogSlot As Integer, ByVal wPMode As Integer) As Boolean
    Apci01wPpollRespModeSet = False
    If hDLL = 0 Then Exit Function
    If Apci01PpollRespModeSet(wLogSlot, wPMode) = 0 Then Exit Function
    Apci01wPpollRespModeSet = True
End Function
'============================================================================
'           BSNXCb`l擾
'           wLogSlot                foCX̘_Xbgԍ
'               wPMode                  armXCb`i[̈
' ߂l            True
'               s    False
'============================================================================
Function Apci01wGetSwitchValue(ByVal wLogSlot As Integer, ByRef pdwSwitchValue As Long) As Boolean
    Apci01wGetSwitchValue = False
    If hDLL = 0 Then Exit Function
    If Apci01GetSwitchValue(wLogSlot, pdwSwitchValue) = 0 Then Exit Function
    Apci01wGetSwitchValue = True
End Function
'============================================================================
'           DIP-SW ̒l擾܂
'           wLogSlot                foCX̘_Xbgԍ
'               pbDipsw                  DIP-SW ̒li[̈
' ߂l            True
'               s    False
'============================================================================
Function Apci01wGetDipSwitch(ByVal wLogSlot As Integer, ByRef pbDipsw As Byte) As Boolean
    Apci01wGetDipSwitch = False
    If hDLL = 0 Then Exit Function
    If Apci01GetDipSwitch(wLogSlot, pbDipsw) = 0 Then Exit Function
    Apci01wGetDipSwitch = True
End Function
'----------------------------------------------------------------------------
'           DLL߰Ċ֐ڽ̎擾
'           
' ߂l            True
'               s    False
'----------------------------------------------------------------------------
Private Function Apci01wGetDllExportFunc() As Boolean
    Dim pFunc As Long

    Apci01wGetDllExportFunc = False
    pFunc = GetProcAddress(hDLL, "Apci01GetLastError")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci01GetStatus")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci01GetVersion")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci01Create")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci01Close")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci01GetResource")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci01Init")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci01SetTime")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci01SetEos")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci01SendCmd")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci01Ifc")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci01Ren")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci01Dcl")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci01Sdc")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci01SendDataCN")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci01SendDataC")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci01SendDataS")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci01RecvDataC")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci01RecvDataS")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci01TransDataN")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci01TransData")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci01SetSrqLine")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci01GetSrqLine")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci01Spoll")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci01Ppoll")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci01PpollConfig")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci01PpollUnConfig")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci01PpollUnConfigAll")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci01PpollRespModeSet")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci01GetSwitchValue")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci01GetDipSwitch")
    If pFunc = 0 Then Exit Function
    
    
    ' SĂ DLL ߰Ċ֐ڽ擾nj
    Apci01wGetDllExportFunc = True
End Function



