//===================================================================
// Apci01w.c
//-------------------------------------------------------------------
// aPCI-G01
// Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//===================================================================
#include <windows.h>
#include <tchar.h>
#include "Apci01w.h"

// -- X^eBbN֐ & X^eBbNϐi萔j
static BOOL 	_Apci01wGetDllExportFunc( void );
static HMODULE 	hDLL = NULL;
// -- GNX|[g֐AhX̊i[pϐ
static	FARPROC	pApci01GetLastError;
static	FARPROC	pApci01GetStatus;
static	FARPROC	pApci01GetVersion;
static	FARPROC	pApci01Create;
static	FARPROC	pApci01Close;
static	FARPROC	pApci01GetResource;
static	FARPROC	pApci01Init;
static	FARPROC	pApci01SetTime;
static	FARPROC	pApci01SetEos;
static	FARPROC	pApci01SendCmd;
static	FARPROC	pApci01Ifc;
static	FARPROC	pApci01Ren;
static	FARPROC	pApci01Dcl;
static	FARPROC	pApci01Sdc;
static	FARPROC	pApci01SendDataCN;
static	FARPROC	pApci01SendDataC;
static	FARPROC	pApci01SendDataS;
static	FARPROC	pApci01RecvDataC;
static	FARPROC	pApci01RecvDataS;
static	FARPROC	pApci01TransDataN;
static	FARPROC	pApci01TransData;
static	FARPROC	pApci01SetSrqLine;
static	FARPROC	pApci01GetSrqLine;
static	FARPROC	pApci01Spoll;
static	FARPROC	pApci01Ppoll;
static	FARPROC	pApci01PpollConfig;
static	FARPROC	pApci01PpollUnConfig;
static	FARPROC	pApci01PpollUnConfigAll;
static	FARPROC	pApci01PpollRespModeSet;
static	FARPROC pApci01GetSwitchValue;
static	FARPROC pApci01GetDipSwitch;

//===================================================================
//   		DLL [h
//   		Ȃ
// ߂l		TRUE	
//				FALSE	s
//===================================================================
BOOL Apci01wDllOpen( VOID )
{
	if ( hDLL != NULL ) return FALSE;
	hDLL = (HMODULE)LoadLibrary(APCI01_DLL_NAME);
	if ( hDLL == NULL ) return FALSE;
	if ( _Apci01wGetDllExportFunc() == FALSE ) {
		Apci01wDllClose();
		return FALSE;
	}
	return TRUE;
}
//===================================================================
//   		DLL A[h
//   		Ȃ
// ߂l		TRUE	
//				FALSE	s
//===================================================================
BOOL Apci01wDllClose( VOID )
{
	if ( hDLL == NULL ) return FALSE;
	if ( FreeLibrary(hDLL) == TRUE ) {
		hDLL = NULL;
		return TRUE;
	}
	return FALSE;
}
//===================================================================
//   		G[R[h擾
//   		wLogSlot		foCX
// ߂l		G[R[h
//===================================================================
DWORD Apci01wGetLastError( WORD wLogSlot )
{
	if ( hDLL == NULL ) return APCI01_ERR_WRAPDLL;
	return (*pApci01GetLastError)(wLogSlot);
}
//===================================================================
//   		GPIBXe[^X̎擾
//   		wLogSlot		foCX
// ߂l		TRUE	
//				FALSE	s
//===================================================================
DWORD Apci01wGetStatus( WORD wLogSlot )
{
	if ( hDLL == NULL ) return FALSE;
	return (*pApci01GetStatus)(wLogSlot);
}
//===================================================================
//   		o[Wԍ擾
//   		pdwDllVersion	DLL o[Wi[̈ւ̃|C^
//				pdwDrvVersion	DRV o[Wi[̈ւ̃|C^
// ߂l		TRUE	
//				FALSE	s
//===================================================================
BOOL Apci01wGetVersion( PDWORD pdwDllVersion, PDWORD pdwDrvVersion )
{
	if ( hDLL == NULL ) return FALSE;
	return (*pApci01GetVersion)(pdwDllVersion, pdwDrvVersion);
}
//===================================================================
//   		foCX̎gp錾
//   		pwLogSlot		foCXi[̈ւ̃|C^
// ߂l		TRUE	
//				FALSE	s
//===================================================================
BOOL Apci01wCreate( PWORD pwLogSlot )
{
	if ( hDLL == NULL ) return FALSE;
	return (*pApci01Create)(pwLogSlot);
}
//===================================================================
//   		foCX̉
//   		wLogSlot		foCX
// ߂l		TRUE	
//				FALSE	s
//===================================================================
BOOL Apci01wClose( WORD wLogSlot )
{
	if ( hDLL == NULL ) return FALSE;
	return (*pApci01Close)(wLogSlot);
}
//===================================================================
//   		\[X擾
//   		wLogSlot		foCX
//				pres			\[Xi[̈ւ̃|C^
// ߂l		TRUE	
//				FALSE	s
//===================================================================
BOOL Apci01wGetResource( WORD wLogSlot, PAPCI01RESOURCE pResInfo )
{
	if ( hDLL == NULL ) return FALSE;
	return	(*pApci01GetResource)(wLogSlot, pResInfo);
}
//===================================================================
//   		
//   		wLogSlot		foCX̘_Ĕԍ
//				wGpibAddr   	g GP-IB AhX
//				wGpibMode		g GP-IB 샂[h
//				dwFifoSize		Mobt@̑傫
// ߂l 		 	TRUE
//				s 	FALSE
//===================================================================
BOOL Apci01wInit( WORD wLogSlot, WORD wGpibAddr, WORD wGpibMode, DWORD dwFifoSize )
{
	if ( hDLL == NULL ) return FALSE;
	return (*pApci01Init)(wLogSlot, wGpibAddr, wGpibMode, dwFifoSize);
}
//===================================================================
//   		GPIBѱĐݒ
//   		wLogSlot		foCX̘_Ĕԍ
//				dwTimeoutCnt  	^CAEglBPʂ̓~b0`60000܂ŁB
// ߂l 		 	TRUE
//				s 	FALSE
//===================================================================
BOOL Apci01wSetTime( WORD wLogSlot, DWORD dwTimeoutCnt )
{
	if ( hDLL == NULL ) return FALSE;
	return (*pApci01SetTime)(wLogSlot, dwTimeoutCnt);
}
//===================================================================
//   		EOIݒ
//   		wLogSlot		foCX̘_Ĕԍ
//				wDlmMode    	f~^w
//				wEoiMode    	dnh̎gp܂͕sgpw
// ߂l 		 	TRUE
//				s 	FALSE
//===================================================================
BOOL Apci01wSetEos( WORD wLogSlot, WORD wDlmMode, WORD wEoiMode )
{
	if ( hDLL == NULL ) return FALSE;
	return (*pApci01SetEos)(wLogSlot, wDlmMode, wEoiMode);
}
//===================================================================
//   		GPIBޑM(۰חp)
//   		wLogSlot		foCX̘_Ĕԍ
//				paSendBuf   	MR}hobt@̃AhX
//				dwSendBytes		MׂR}h̃oCg
// ߂l 		 	TRUE
//				s 	FALSE
//===================================================================
BOOL Apci01wSendCmd( WORD wLogSlot, PBYTE paSendBuf, DWORD dwSendBytes )
{
	if ( hDLL == NULL ) return FALSE;
	return (*pApci01SendCmd)(wLogSlot, paSendBuf, dwSendBytes);
}
//===================================================================
//   		IFCM(۰חp)
//   		wLogSlot		foCX̘_Ĕԍ
// ߂l 		 	TRUE
//				s 	FALSE
//===================================================================
BOOL Apci01wIfc( WORD wLogSlot )
{
	if ( hDLL == NULL ) return FALSE;
	return (*pApci01Ifc)(wLogSlot);
}
//===================================================================
//   		RENײ݂̐ݒ(۰חp)
//   		wLogSlot		foCX̘_Ĕԍ
//				wRenLine		1(^)/0(U)
// ߂l 		 	TRUE
//				s 	FALSE
//===================================================================
BOOL Apci01wRen( WORD wLogSlot, WORD wRenLine )
{
	if ( hDLL == NULL ) return FALSE;
	return (*pApci01Ren)(wLogSlot, wRenLine);
}
//===================================================================
//   		DCLM(۰חp)
//   		wLogSlot		foCX̘_Ĕԍ
// ߂l		 	TRUE
//				s 	FALSE
//===================================================================
BOOL Apci01wDcl( WORD wLogSlot )
{
	if ( hDLL == NULL ) return FALSE;
	return (*pApci01Dcl)(wLogSlot);
}
//===================================================================
//   		w@ւSDCM(۰חp)
//   		wLogSlot		foCX̘_Ĕԍ
//				wLsnAdrs		XiAhX
// ߂l 		 	TRUE
//				s 	FALSE
//===================================================================
BOOL Apci01wSdc( WORD wLogSlot, WORD wLsnAdrs )
{
	if ( hDLL == NULL ) return FALSE;
	return (*pApci01Sdc)(wLogSlot, wLsnAdrs);
}
//===================================================================
//   		̎w@ւްM(۰חp)
//   		wLogSlot		foCX̘_Ĕԍ
//				pwLsnAdrsList 	XiAhXXg̃AhX
//				wLsnAdrsCnt		XiAhX̐
//				pbSendBuff		Mf[^obt@̃AhX
//				dwDataCnt		Mf[^
// ߂l 		 	TRUE
//				s 	FALSE
//===================================================================
BOOL Apci01wSendDataCN( WORD wLogSlot, PWORD pwLsnAdrsList, WORD wLsnAdrsCnt, PBYTE pbSendBuff, DWORD dwDataCnt )
{
	if ( hDLL == NULL ) return FALSE;
	return (*pApci01SendDataCN)(wLogSlot, pwLsnAdrsList, wLsnAdrsCnt, pbSendBuff, dwDataCnt);
}
//===================================================================
//   		w@ւްM(۰חp)
//   		wLogSlot		foCX̘_Ĕԍ
//				wLsnAdrs		XiAhX
//				pbSendBuff		Mf[^obt@̃AhX
//				dwDataCnt   	Mf[^
// ߂l 		 	TRUE
//				s 	FALSE
//===================================================================
BOOL Apci01wSendDataC( WORD wLogSlot, WORD wLsnAdrs, PBYTE pbSendBuff, DWORD dwDataCnt )
{
	if ( hDLL == NULL ) return FALSE;
	return (*pApci01SendDataC)(wLogSlot, wLsnAdrs, pbSendBuff, dwDataCnt);
}
//===================================================================
//   		ްM(ڰޗp)
//   		wLogSlot		foCX̘_Ĕԍ
//				pbSendBuff		Mf[^obt@̃AhX
//				dwDataCnt		Mf[^
// ߂l 		 	TRUE
//				s 	FALSE
//===================================================================
BOOL Apci01wSendDataS( WORD wLogSlot, PBYTE pbSendBuff, DWORD dwDataCnt )
{
	if ( hDLL == NULL ) return FALSE;
	return (*pApci01SendDataS)(wLogSlot, pbSendBuff, dwDataCnt);
}
//===================================================================
//   		w@킩ްM(۰חp)
//   		wLogSlot		foCX̘_Ĕԍ
//				wTlkAdrs		g[JAhX
//				pbRecvBuff		Mf[^obt@̃AhX
//				pdwDataCnt		Mf[^w肷ϐ̃AhX
// ߂l 		 	TRUE
//				s 	FALSE
//===================================================================
BOOL Apci01wRecvDataC( WORD wLogSlot, WORD wTlkAdrs, PBYTE pbRecvBuff, PDWORD pdwDataCnt )
{
	if ( hDLL == NULL ) return FALSE;
	return (*pApci01RecvDataC)(wLogSlot, wTlkAdrs, pbRecvBuff, pdwDataCnt);
}
//===================================================================
//   		ްM(ڰޗp)
//   		wLogSlot		foCX̘_Ĕԍ
//				pbRecvBuff 		Mf[^obt@̃AhX
//				pdwDataCnt  	Mf[^w肷ϐ̃AhX
// ߂l 		 	TRUE
//				s 	FALSE
//===================================================================
BOOL Apci01wRecvDataS( WORD wLogSlot, PBYTE pbRecvBuff, PDWORD pdwDataCnt )
{
	if ( hDLL == NULL ) return FALSE;
	return (*pApci01RecvDataS)(wLogSlot, pbRecvBuff, pdwDataCnt);
}
//===================================================================
//   		@ް](۰חp)
//   		wLogSlot		foCX̘_Ĕԍ
//				wTlkAdrs      	g[JAhX
//				pwLsnAdrsList	XiAhXXg̃AhX
//				wLsnAdrsCnt		XiAhX̐
// ߂l 		 	TRUE
//				s 	FALSE
//===================================================================
BOOL Apci01wTransDataN( WORD wLogSlot, WORD wTlkAdrs, PWORD pwLsnAdrsList, WORD wLsnAdrsCnt )
{
	if ( hDLL == NULL ) return FALSE;
	return (*pApci01TransDataN)(wLogSlot, wTlkAdrs, pwLsnAdrsList, wLsnAdrsCnt);
}
//===================================================================
//   		@ް](۰חp)
//   		wLogSlot		foCX̘_Ĕԍ
//				wTlkAdrs		g[JAhX
//				wLsnAdrs		XiAhX
// ߂l 		 	TRUE
//				s 	FALSE
//===================================================================
BOOL Apci01wTransData( WORD wLogSlot, WORD wTlkAdrs, WORD wLsnAdrs )
{
	if ( hDLL == NULL ) return FALSE;
	return (*pApci01TransData)(wLogSlot, wTlkAdrs, wLsnAdrs);
}
//===================================================================
//   		SRQײ݂ƽð޲Đݒ(ڰޗp)
//   		wLogSlot		foCX̘_Ĕԍ
//				bStsByte		Xe[^XoCgl
// ߂l 		 	TRUE
//				s 	FALSE
//===================================================================
BOOL Apci01wSetSrqLine( WORD wLogSlot, BYTE bStsByte )
{
	if ( hDLL == NULL ) return FALSE;
	return (*pApci01SetSrqLine)(wLogSlot, bStsByte);
}
//===================================================================
//   		SRQײ݂̏Ԕ(۰חp)
//   		wLogSlot		foCX̘_Ĕԍ
//				pwSrqLine		rqpCԂi[ϐ̃AhX
// ߂l 		 	TRUE
//				s 	FALSE
//===================================================================
BOOL Apci01wGetSrqLine( WORD wLogSlot, PWORD pwSrqLine )
{
	if ( hDLL == NULL ) return FALSE;
	return (*pApci01GetSrqLine)(wLogSlot, pwSrqLine);
}
//===================================================================
//   		رَ߰s(۰חp)
//   		wLogSlot		foCX̘_Ĕԍ
//				wPollAdrs		|[ÕAhX
//				pbStsByte		Xe[^XoCgi[ϐ̃AhX
// ߂l 		 	TRUE
//				s 	FALSE
//===================================================================
BOOL Apci01wSpoll( WORD wLogSlot, WORD wPollAdrs, PBYTE pbStsByte )
{
	if ( hDLL == NULL ) return FALSE;
	return (*pApci01Spoll)(wLogSlot, wPollAdrs, pbStsByte);
}
//===================================================================
//   		َ߰s(۰חp)
//   		wLogSlot		foCX̘_Ĕԍ
//				pbDioLine   	chnCi[ϐ̃AhX
// ߂l 		 	TRUE
//				s 	FALSE
//===================================================================
BOOL Apci01wPpoll( WORD wLogSlot, PBYTE pbDioLine )
{
	if ( hDLL == NULL ) return FALSE;
	return (*pApci01Ppoll)(wLogSlot, pbDioLine);
}
//===================================================================
//   		ٍ߰\(۰חp)
//   		wLogSlot		foCX̘_Ĕԍ
//				wLsnAdrs		\@AhX
//				bDioLine    	@tDIOCԍiO`ṼrbgԍŎwj
//				bSbit			ZXrbg̎wiO܂͂Pj
// ߂l 		 	TRUE
//				s 	FALSE
//===================================================================
BOOL Apci01wPpollConfig( WORD wLogSlot, WORD wLsnAdrs, BYTE bDioLine, BYTE bSbit )
{
	if ( hDLL == NULL ) return FALSE;
	return (*pApci01PpollConfig)(wLogSlot, wLsnAdrs, bDioLine, bSbit);
}
//===================================================================
//   		w@ٍ߰\(۰חp)
//   		wLogSlot		foCX̘_Ĕԍ
//				wLsnAdrs		\@AhX
// ߂l 		 	TRUE
//				s 	FALSE
//===================================================================
BOOL Apci01wPpollUnConfig( WORD wLogSlot, WORD wLsnAdrs )
{
	if ( hDLL == NULL ) return FALSE;
	return (*pApci01PpollUnConfig)(wLogSlot, wLsnAdrs);
}
//===================================================================
//   		S@ٍ߰\(۰חp)
//   		wLogSlot		foCX̘_Ĕԍ
// ߂l 		 	TRUE
//				s 	FALSE
//===================================================================
BOOL Apci01wPpollUnConfigAll( WORD wLogSlot )
{
	if ( hDLL == NULL ) return FALSE;
	return (*pApci01PpollUnConfigAll)(wLogSlot);
}
//===================================================================
//   		߰ىݒ(ڰޗp)
//   		wLogSlot		foCX̘_Ĕԍ
//				wPMode			p|[ւ̉@
// ߂l 		 	TRUE
//				s 	FALSE
//===================================================================
BOOL Apci01wPpollRespModeSet( WORD wLogSlot, WORD wPMode )
{
	if ( hDLL == NULL ) return FALSE;
	return (*pApci01PpollRespModeSet)(wLogSlot, wPMode);
}
//===================================================================
//   		arm̒l擾
//   		wLogSlot		foCX̘_Ĕԍ
//				pdwSwitchValue	arm̒li[̈ւ̃|C^
// ߂l 		 	TRUE
//				s 	FALSE
//===================================================================
BOOL Apci01wGetSwitchValue(WORD wLogSlot,PDWORD pdwSwitchValue)
{
	if ( hDLL == NULL ) return FALSE;
	return (*pApci01GetSwitchValue)(wLogSlot, pdwSwitchValue);
}
//===================================================================
//   		cho|rv̒l擾
//   		wLogSlot		foCX̘_Ĕԍ
//				pbDipsw			rvli[̈ւ̃|C^
// ߂l 		 	TRUE
//				s 	FALSE
//===================================================================
BOOL Apci01wGetDipSwitch(WORD wLogSlot, PBYTE pbDipsw)
{
	if ( hDLL == NULL ) return FALSE;
	return (*pApci01GetDipSwitch)(wLogSlot, pbDipsw);
}
//-------------------------------------------------------------------
//   	  	DLL߰Ċ֐ڽ̎擾
//   	  	
// ߂l 		 	TRUE
//		  		s 	FALSE
//-------------------------------------------------------------------
static BOOL _Apci01wGetDllExportFunc ( void )
{
	pApci01GetLastError = GetProcAddress(hDLL, _T("Apci01GetLastError"));
	if (pApci01GetLastError == NULL)	return FALSE;
	pApci01GetStatus = GetProcAddress(hDLL, _T("Apci01GetStatus"));
	if (pApci01GetStatus == NULL)	return FALSE;
	pApci01GetVersion = GetProcAddress(hDLL, _T("Apci01GetVersion"));
	if (pApci01GetVersion == NULL)	return FALSE;
	pApci01Create = GetProcAddress(hDLL, _T("Apci01Create"));
	if (pApci01Create == NULL)	return FALSE;
	pApci01Close = GetProcAddress(hDLL, _T("Apci01Close"));
	if (pApci01Close == NULL)	return FALSE;
	pApci01GetResource = GetProcAddress(hDLL, _T("Apci01GetResource"));
	if (pApci01GetResource == NULL)	return FALSE;
	pApci01Init = GetProcAddress(hDLL, _T("Apci01Init"));
	if (pApci01Init == NULL)	return FALSE;
	pApci01SetTime = GetProcAddress(hDLL, _T("Apci01SetTime"));
	if (pApci01SetTime == NULL)	return FALSE;
	pApci01SetEos = GetProcAddress(hDLL, _T("Apci01SetEos"));
	if (pApci01SetEos == NULL)	return FALSE;
	pApci01SendCmd = GetProcAddress(hDLL, _T("Apci01SendCmd"));
	if (pApci01SendCmd == NULL)	return FALSE;
	pApci01Ifc = GetProcAddress(hDLL, _T("Apci01Ifc"));
	if (pApci01Ifc == NULL)	return FALSE;
	pApci01Ren = GetProcAddress(hDLL, _T("Apci01Ren"));
	if (pApci01Ren == NULL)	return FALSE;
	pApci01Dcl = GetProcAddress(hDLL, _T("Apci01Dcl"));
	if (pApci01Dcl == NULL)	return FALSE;
	pApci01Sdc = GetProcAddress(hDLL, _T("Apci01Sdc"));
	if (pApci01Sdc == NULL)	return FALSE;
	pApci01SendDataCN = GetProcAddress(hDLL, _T("Apci01SendDataCN"));
	if (pApci01SendDataCN == NULL)	return FALSE;
	pApci01SendDataC = GetProcAddress(hDLL, _T("Apci01SendDataC"));
	if (pApci01SendDataC == NULL)	return FALSE;
	pApci01SendDataS = GetProcAddress(hDLL, _T("Apci01SendDataS"));
	if (pApci01SendDataS == NULL)	return FALSE;
	pApci01RecvDataC = GetProcAddress(hDLL, _T("Apci01RecvDataC"));
	if (pApci01RecvDataC == NULL)	return FALSE;
	pApci01RecvDataS = GetProcAddress(hDLL, _T("Apci01RecvDataS"));
	if (pApci01RecvDataS == NULL)	return FALSE;
	pApci01TransDataN = GetProcAddress(hDLL, _T("Apci01TransDataN"));
	if (pApci01TransDataN == NULL)	return FALSE;
	pApci01TransData = GetProcAddress(hDLL, _T("Apci01TransData"));
	if (pApci01TransData == NULL)	return FALSE;
	pApci01SetSrqLine = GetProcAddress(hDLL, _T("Apci01SetSrqLine"));
	if (pApci01SetSrqLine == NULL)	return FALSE;
	pApci01GetSrqLine = GetProcAddress(hDLL, _T("Apci01GetSrqLine"));
	if (pApci01GetSrqLine == NULL)	return FALSE;
	pApci01Spoll = GetProcAddress(hDLL, _T("Apci01Spoll"));
	if (pApci01Spoll == NULL)	return FALSE;
	pApci01Ppoll = GetProcAddress(hDLL, _T("Apci01Ppoll"));
	if (pApci01Ppoll == NULL)	return FALSE;
	pApci01PpollConfig = GetProcAddress(hDLL, _T("Apci01PpollConfig"));
	if (pApci01PpollConfig == NULL)	return FALSE;
	pApci01PpollUnConfig = GetProcAddress(hDLL, _T("Apci01PpollUnConfig"));
	if (pApci01PpollUnConfig == NULL)	return FALSE;
	pApci01PpollUnConfigAll = GetProcAddress(hDLL, _T("Apci01PpollUnConfigAll"));
	if (pApci01PpollUnConfigAll == NULL)	return FALSE;
	pApci01PpollRespModeSet = GetProcAddress(hDLL, _T("Apci01PpollRespModeSet"));
	if (pApci01PpollRespModeSet == NULL)	return FALSE;
	pApci01GetSwitchValue = GetProcAddress(hDLL, _T("Apci01GetSwitchValue"));
	if (pApci01GetSwitchValue == NULL)	return FALSE;
	pApci01GetDipSwitch = GetProcAddress(hDLL, _T("Apci01GetDipSwitch"));
	if (pApci01GetDipSwitch == NULL)	return FALSE;

	// SĂ DLL ߰Ċ֐ڽ擾nj
	return TRUE;
}

